
/**
base_stx.js

function getAllElements();
function getFormElements(form);
function getElementByName(name);
function getElementByNameFromForm(form, name);
function getElementByNameFromDocument(name);
function getElementsByName(name);
function getElementsByNameFromForm(form, name);
function getElementsByNameFromDocument(name);
function getElementByName2(name);
function getElementsByName2(name);
function getDynamicTableElements();
function getNextFocusElement(element_focus, forward);
function getName(element);
function getValueByName(name);
function setValue(element, value);
function setValue2Hidden(name, name4hidden, value);
function round(value, nDecimal);
function isNumber(str_number);
function getNumber(str_number);
function getNumberByName(name);
function getInnerHTML(str);
function unlockForm(event, url);
function getValueType(str_value);
function getValue_daytime(str_value);
function checkDate2(year, month, day);
function checkTime2(hour, minute, second);

StraFormDesigner Ver1.5
Copyright(C) 2004-2008 FIT Corporation All Rights Reserved.

Last Update 2008/09/08
*/

/*@cc_on _d=document;eval('var document=_d')@*/

var browserType = 0;
// IE、Opera
if( document.all ){
  // IE
  if( !window.opera )
    browserType = 0;
  // Opera
  else
    browserType = 2;
// NetScape、FireFox
} else if( document.getElementById ) {
  browserType = 1;
}

/** Element配列を取得 */
function getAllElements(){
  var all = null;
  switch(browserType){
    // 
    case 0:
    case 2:
      all = document.all;
      break;

    // 
    case 1:
      all = document.getElementsByTagName("*");
      break;
  }

  return all;
}

/** フォーム内からElement配列を取得 */
function getFormElements(form){
  return form.elements;
}

/** フォーム内からElementを取得 */
function getElementByName(name){
  return getElementByNameFromForm(document.form, name);
}

/** フォーム内からElementを取得 */
function getElementByNameFromForm(form, name){
  var all = getFormElements(form);

  // 
  var nElement = all.length;
  for(var ii = 0; ii < nElement; ii++){
    if(all[ii].name == name)
      return all[ii];
  }

  return null;
}

/** ドキュメント内からElementを取得 */
function getElementByNameFromDocument(name){
  var all = getAllElements();

  // 
  var nElement = all.length;
  for(var ii = 0; ii < nElement; ii++){
    if(all[ii].attributes != null){
      var attr_name = all[ii].attributes.getNamedItem("name");
      if(attr_name != null && attr_name.nodeValue == name)
        return all[ii];
    }
  }

  return null;
}

/** フォーム内からElement配列を取得 */
function getElementsByName(name){
  return getElementsByNameFromForm(document.form, name);
}

/** フォーム内からElement配列を取得 */
function getElementsByNameFromForm(form, name){
  var index = 0;
  var elements = new Array();
  var all = getFormElements(form);

  // 
  var nElement = all.length;
  for(var ii = 0; ii < nElement; ii++){
    if(all[ii].name == name)
      elements[ index++ ] = all[ii];
  }

  if(index != 0)
    return elements;

  return null;
}

/** ドキュメント内からElement配列を取得 */
function getElementsByNameFromDocument(name){
  var index = 0;
  var elements = new Array();
  var all = getAllElements();

  // 
  var nElement = all.length;
  for(var ii = 0; ii < nElement; ii++){
    if(all[ii].attributes != null){
      var attr_name = all[ii].attributes.getNamedItem("name");
      if(attr_name != null && attr_name.nodeValue == name)
        elements[ index++ ] = all[ii];
    }
  }

  if(index != 0)
    return elements;

  return null;
}

/** フォーム内からElementを取得 */
function getElementByName2(name){
  return document.getElementsByName(name)[0];
}

/** フォーム内からElement配列を取得 */
function getElementsByName2(name){
  var elements = document.getElementsByName(name);
  if(elements.length != 0)
    return elements;
  else
    return null;
}

/** 追加テーブルのElementを取得 */
function getDynamicTableElements(){
  var all = getFormElements( document.form );

  // 
  var nElement = all.length;
  for(var ii = 0; ii < nElement; ii++){
    var element = all[ii];
    if(element.name == "TABLE_ID"){
      var elements = new Array();
      var strs_name = element.value.split(", ");

      var length_strs_name = strs_name.length;
      for(var jj = 0; jj < length_strs_name; jj++)
        elements[jj] = getElementByName2( strs_name[jj] );

      return elements;
    }
  }

  return null;
}

/** 次にフォーカスが移動するElementを取得 */
function getNextFocusElement(element_focus, forward){
  var tabIndex_focus = element_focus.tabIndex;
  var tabIndex_min = Number.MAX_VALUE;
  var tabIndex_max = Number.MIN_VALUE;
  var tabIndex_foward = Number.MAX_VALUE;
  var tabIndex_back = Number.MIN_VALUE;
  var element_min;
  var element_max;
  var element_foward;
  var element_back;
  var all = getAllElements();

  // 
  var nElement = all.length;
  for(var ii = 0; ii < nElement; ii++){
    var element = all[ii];

    var tagName = element.tagName;
    if((tagName == "INPUT" || tagName == "TEXTAREA" || tagName == "SELECT" || tagName == "SPAN" || tagName == "DIV" || tagName == "TD" || tagName == "TABLE") && element.className != "")
      ;
    else
      continue;

    var tabIndex = element.tabIndex;
    if(tabIndex != 0 && !element.disabled){
      if(element.attributes.getNamedItem("name").nodeValue != element_focus.attributes.getNamedItem("name").nodeValue){
        // 降順
        if(forward){
          if(tabIndex < tabIndex_min){
            tabIndex_min = tabIndex;
            element_min = element;
          }

          if(tabIndex > tabIndex_focus && tabIndex < tabIndex_foward){
            tabIndex_foward = tabIndex;
            element_foward = element;
          }
        // 昇順
        } else {
          if(tabIndex > tabIndex_max){
            tabIndex_max = tabIndex;
            element_max = element;
          }

          if(tabIndex < tabIndex_focus && tabIndex > tabIndex_back){
            tabIndex_back = tabIndex;
            element_back = element;
          }
        }
      }
    }
  }

  var element_nextFocus;

  // 降順
  if(forward){
    element_nextFocus = element_foward;
    if(tabIndex_foward == Number.MAX_VALUE)
      element_nextFocus = element_min;
  // 昇順
  } else {
    element_nextFocus = element_back;
    if(tabIndex_back == Number.MIN_VALUE)
      element_nextFocus = element_max;
  }

  return element_nextFocus;
}

/** 名前を取得 */
function getName(element){
  // ラベルの場合
  if(element.tagName == "SPAN")
    name = element.attributes.getNamedItem("name").nodeValue;
  else
    name = element.name;

  return name;
}

/** 値を取得 */
function getValueByName(name){
  var value = "";

  // 
  var elements = getElementsByName2(name);
  if(elements != null){
    var nElement = elements.length;
    for(var ii = 0; ii < nElement; ii++){
      var element = elements[ii];

      // ラベルの場合
      if(element.tagName == "SPAN"){
        value = getInnerHTML( element.innerHTML );
      // コンボボックス、リストの場合
      } else if(element.tagName == "SELECT") {
        var length_options = element.options.length;
        for(var jj = 0; jj < length_options; jj++){
          if( element.options[jj].selected )
            value += element.options[jj].value;
        }
      } else {
        // チェックボックス場合
        if(element.type == "checkbox"){
          if( element.checked )
            value = element.value;
        // ラジオボタンの場合
        } else if(element.type == "radio") {
          if( element.checked )
            value = element.value;
        // テキストフィールド、パスワードフィールド、テキストエリアの場合
        } else {
          value = element.value;
        }
      }
    }
  }

  return value;
}

/** 値を設定 */
function setValue(element, value){
  if(element.tagName == "SPAN")
    element.innerHTML = value;
  else if(element.tagName != "TABLE")
    element.value = value;
}

/** 隠しフィールドに値を設定 */
function setValue2Hidden(name, name4hidden, value){
  var element_hidden = getElementByName2(name + name4hidden);
  if(element_hidden == null){
    element_hidden = document.createElement("input");
    element_hidden.name = name + name4hidden;
    element_hidden.id = element_hidden.name;
    element_hidden.type = "hidden";
    element_hidden.value = value;

    document.form.appendChild(element_hidden);
  } else {
    element_hidden.value = value;
  }
}

/** 四捨五入 */
function round(value, nDecimal){
  var pow = Math.pow(10, nDecimal - 1);

  return Math.round(value * pow) / pow;
}

/** 数値か判定 */
function isNumber(str_number){
  // カンマを削除
  str_number = str_number.replace(/\,+/ig, "");

  // 通貨表示数を検査
  var nCurrency = str_number.split("\\").length + str_number.split("$").length;
  if(nCurrency > 3)
    return false;

  // 通貨表示位置を検査
  var index = str_number.indexOf("\\");
  if(index == 1){
    var ch = str_number.charAt(0);
    if(ch != "+" && ch != "-")
      return false;
  } else if(index > 2) {
    return false;
  }

  index = str_number.indexOf("$");
  if(index == 1){
    var ch = str_number.charAt(0);
    if(ch != "+" && ch != "-")
      return false;
  } else if(index > 2) {
    return false;
  }

  // 通貨表示を削除
  str_number = str_number.replace(/\\+|\$+/ig, "");

  if( isNaN( Number(str_number) ) )
    return false;
  else
    return true;
}

/**  */
function getNumber(str_number){
  // カンマ、通貨表示を削除
  str_number = str_number.replace(/\\+|\$+|\,+/ig, "");

  var number;
  if( isNaN(str_number) ){
    try{
      number = eval(str_number);
    } catch(e) {
      return 0;
    }
  } else {
    number = Number(str_number);
  }

  if(number >= 10000000000000000)
    return 0;
  else
    return number;
}

/** 値を数値に変換 */
function getNumberByName(name){
  var value = getValueByName(name);

  // 隠しデータの値を取得
  var element_hidden4inputValue = getElementByName2(name + "_hidden4inputValue");
  if(element_hidden4inputValue != null){
    if( !isNumber(value) )
      value = element_hidden4inputValue.value;
  }

  if( isNumber(value) )
    return getNumber(value);
  else
    return 0;
}

/**  */
function getInnerHTML(str){
  // “&nbsp”を半角スペースに変換
  str = str.replace("&nbsp;", " ");

  return str;
}

/** フォームのロックを解除 */
function unlockForm(event, url){
  document.form.NEXT_PAGE.value = url;

  if(event.type == "unload"){
    if(unlockFormFlag)
      post("./cancelform");
    else
      unlockFormFlag = true;
  } else {
    post("./cancelform");
  }
}

/** 入力値タイプを判定（0:文字列 1:数値 2:日付、時刻） */
function getValueType(str_value){
  var valueType = -1;

  nSep_day = 0;
  nSep_time = 0;

  // 
  if(str_value.length == 0){
    valueType = 0;
  // 
  } else if( isNumber(str_value) ){
    valueType = 1;
  } else {
    // 
    if(str_value.charAt(0) == "+" || str_value.charAt(0) == "-"){
      try{
        var str_value2 = eval(str_value);
        if(str_value != str_value2)
          valueType = 1;
      } catch(e) {
      }
    }

    // 
    if(str_value.split("/").length > 3 || str_value.split("-").length > 3 || str_value.split(":").length > 3 || str_value.split(" ").length > 2)
      valueType = 0;

    if(valueType == -1){
      var index_value = 0;
      var sepType = 0;

      var length_str_value = str_value.length;
      for(var ii = 0; ii < length_str_value; ii++){
        var ch = str_value.charAt(ii);
        // 日付、時刻の区切り文字の場合
        if(ch == "/" || ch == "-" || ch == ":" || ch == "年" || ch == "月" || ch == "日" || ch == "時" || ch == "分" || ch == "秒"){
          var str = str_value.substring(index_value, ii);
          // 数値ではない場合
          if(isNaN(str) || str.length == 0){
            valueType = 0;
            break;
          // 数値の場合
          } else {
            // 正の場合
            if(Number(str) >= 0){
              valueType = 2;

              if(ch == "/" || ch == "-"){
                if(sepType != 0 && sepType != 1){
                  valueType = 0;
                  break;
                }

                sepType = 1;
                nSep_day++;
              } else if(ch == "年" || ch == "月" || ch == "日") {
                if(sepType != 0 && sepType != 2){
                  valueType = 0;
                  break;
                }

                sepType = 2;
                nSep_day++;
              } else if(ch == ":") {
                if(sepType != 0 && sepType != 3){
                  valueType = 0;
                  break;
                }

                sepType = 3;
                nSep_time++;
              } else if(ch == "時" || ch == "分" || ch == "秒") {
                if(sepType != 0 && sepType != 4){
                  valueType = 0;
                  break;
                }

                sepType = 4;
                nSep_time++;
              }
            // 負の場合
            } else {
              valueType = 0;
              break;
            }
          }
        // " "
        } else if(ch == " ") {
          if(sepType == 2)
            nSep_day--;
          else if(sepType == 4)
            nSep_time--;

          sepType = 0;
        // その他の場合
        } else {
          // 最後の文字の場合
          if(ii == length_str_value - 1) {
            var str = str_value.substring(index_value, ii + 1);
            // 数値ではない場合
            if(isNaN(str) || str.length == 0){
              valueType = 0;
              break;
            // 数値の場合
            } else {
              // 正の場合
              if(Number(str) >= 0){
                valueType = 2;
              // 負の場合
              } else {
                valueType = 0;
                break;
              }
            }
          // 
          } else {
            // 数値ではない場合
            if(isNaN( Number(ch) ) || ch.length == 0){
              valueType = 0;
              break;
            } else {
              continue;
            }
          }
        }

        index_value = ii + 1;
      }

      if(sepType == 2)
        nSep_day--;
      else if(sepType == 4)
        nSep_time--;

      if(nSep_day > 2 || nSep_time > 2)
        valueType = 0;
    }
  }
//alert(nSep_day + " : " + nSep_time);

  // 
  if(valueType == 2){
    // 
    getValue_daytime(str_value);

    if (nSep_day > 0 && nSep_time > 0) {
      if(checkDate2(year, month, day) != "" || checkTime2(hour, minute, second) != "")
        valueType = 0;
    }
    else if (nSep_day > 0) {
      if (checkDate2(year, month, day) != "")
        valueType = 0;
    }
    else if (nSep_time > 0) {
      if (checkTime2(hour, minute, second) != "")
        valueType = 0;
    }
    
    //
  }

  return valueType;
}

var year;
var year_org;
var month;
var day;
var hour;
var hour_org;
var minute;
var second;
var nSep_day;
var nSep_time;

/** 年月日、時刻を取得する */
function getValue_daytime(str_value){
  // “.”“-”を“/”に変換
  str_value = str_value.replace(/\.+|-+/ig, "/");
  // “:”“ ”“年”“月”“日”“時”“分”“秒”を“/”に変換
  var str_value2 = str_value.replace(/\:+|\s+|年+|月+|日+|時+|分+|秒+/ig, "/");
  // 
  str_value2 = str_value2.replace(/\/+/ig, "/");
  // 
  if(str_value2.lastIndexOf("/") == str_value2.length - 1)
    str_value2 = str_value2.substring(0, str_value2.length - 1);

  // 
  var tokens_value = str_value2.split("/");
  var length_tokens_value = tokens_value.length;
  var index_tokens = 0;

  // 年月日を取得
  if(nSep_day == 1){
    var value = Number( tokens_value[0] );
    if(value > 12){
      year = value;
      month = Number( tokens_value[1] );
      if(month > 12){
        tokens_format = new Array();
        tokens_format[0] = "@";

        return;
      }
    } else {
      month = value;
      if(month > 12){
        tokens_format = new Array();
        tokens_format[0] = "@";

        return;
      }

      day = Number( tokens_value[1] );
      if(day > 31){
        tokens_format = new Array();
        tokens_format[0] = "@";

        return;
      }
    }

    index_tokens = 2;
  } else if(nSep_day == 2) {
    year = Number( tokens_value[0] );
    if(year <= 29){
      year += 2000;
    } else if(year <= 99) {
      year += 1900;
    } else if(year >= 10000) {
      tokens_format = new Array();
      tokens_format[0] = "@";

      return;
    }

    month = Number( tokens_value[1] );
    if(month > 12){
      tokens_format = new Array();
      tokens_format[0] = "@";

      return;
    }

    day = Number( tokens_value[2] );
    if(day > 31){
      tokens_format = new Array();
      tokens_format[0] = "@";

      return;
    }

    index_tokens = 3;
  }

  // 時刻を取得
  if(nSep_time == 1){
    hour = Number( tokens_value[index_tokens] );
    if(hour >= 10000){
      tokens_format = new Array();
      tokens_format[0] = "@";

      return;
    } else {
      if(hour == 24)
        hour = 12;
      else
        hour %= 24;
    }

    hour_org = hour;
    minute = Number( tokens_value[index_tokens + 1] );
  } else if(nSep_time == 2) {
    hour = Number( tokens_value[index_tokens] );
    if(hour >= 10000){
      tokens_format = new Array();
      tokens_format[0] = "@";

      return;
    } else {
      if(hour == 24)
        hour = 12;
      else
        hour %= 24;
    }

    hour_org = hour;
    minute = Number( tokens_value[index_tokens + 1] );
    second = Number( tokens_value[index_tokens + 2] );
  }
}

/**  */
function checkDate2(year, month, day){
  var str_error = "";

  // 年を検査
  if(year != null && (year < 1000 || year >= 10000))
    str_error = "年が不正です（" + year + "）\r\n";

  // 月を検査
  if(month < 1 || month > 12)
    str_error += "月が不正です（" + month + "）\r\n";

  // 日を検査
  if((day != null && isNaN(day)) || day <= 0 || day > 30 + ((month == 4 || month == 6 || month ==9 || month == 11)? 0:1) || 
    (month == 2 && day > 28 + (((year % 4 == 0 && year % 100 != 0) || year % 400 == 0)? 1:0)))
    str_error += "日にちが不正です（" + day + "）\r\n";

  return str_error;
}

/** 有効な時刻かを検査 */
function checkTime2(hour, minute, second){
  var str_error = "";

  // 時間を検査
  if(hour != null && (hour < 0 || hour > 24))
    str_error = "時間が不正です（" + hour + "）\r\n";

  // 分を検査
  if(minute < 0 || minute > 60)
    str_error = "分が不正です（" + minute + "）\r\n";

  // 秒を検査
  if(second != null && (second < 0 || second > 60))
    str_error = "秒が不正です（" + second + "）\r\n";

  return str_error;
}

/**
property_stx.js

function focusByEnterKey(event);
function showComment(visibility, element, event);
function checkEssentialItems(arrays);
function checkEssentialItems2(arrays);
function checkStringLength(element, maxLength, minLength);
function checkValueType(checkType, element);
function checkValueType2(checkType, element, maxValue, minValue, customRegExp, errorMessage);
function getCharacterType(value);
function checkNumberLimit(value, maxValue, minValue);
function convertCharacter(value, str1, str2);
function checkDate(str_value);
function checkTime(str_value);
function checkZipCode(str_value);
function checkTelephoneNumber(str_value);
function checkMobilephoneNumber(str_value);
function checkURL(str_value);
function checkMailAddress(str_value);
function checkCustomRegExp(str_value, customRegExp, str_error);
function insertComma2String(str_value);

StraFormDesigner Ver1.5
Copyright(C) 2004-2008 FIT Corporation All Rights Reserved.

Last Update 2008/04/14
*/

/** Enterキー押下でフォーカスを移動する */
function focusByEnterKey(event){
  // Enterキーが押下されている場合
  var keyCode;
  switch(browserType){
    // 
    case 0:
    case 2:
      keyCode = event.keyCode;
      break;

    // 
    case 1:
      keyCode = (event.keyCode != 0) ? event.keyCode : event.charCode;
      break;
  }

  // Enterキーのキーコードを変更
  if(keyCode == 0x0A)
    keyCode = 0x0D;

  if(keyCode != 0x0D)
    return;

  event.returnValue = false;
  event.cancelBubble = true;

  var element;
  switch(browserType){
    // 
    case 0:
    case 2:
      element = event.srcElement;
      break;

    // 
    case 1:
      element = event.target;
      break;
  }

  var tagName = element.tagName;

  // テキストエリアの場合、CTRLキーとEnterキーを同時押下で改行する
  if(tagName == "TEXTAREA" && event.ctrlKey){
    switch(browserType){
      // 
      case 0:
      case 2:{
        var textRange = document.selection.createRange();
        if(textRange != null){
          var offsetLeft = textRange.offsetLeft;
          var offsetTop = textRange.offsetTop;
          textRange = element.createTextRange();
          textRange.moveToPoint(offsetLeft, offsetTop);

          textRange.text = "\r\n";
          textRange.select();
        } else {
          element.value += "\r\n";
        }
      }
      break;

      // 
      case 1:{
        var selectionStart = element.selectionStart;

        var front = element.value.substring(0, element.selectionStart);
        var back = element.value.substring(element.selectionStart, element.value.length);
        element.value = front + "\r\n" + back;

        element.selectionStart = selectionStart + 1;
        element.selectionEnd = selectionStart + 1;
      }
      break;
    }

    return;
  }

  // SHIFTキーが押下されていない場合
  if( !event.shiftKey ){
    // ボタンの場合、ボタンを押下する
    if(element.type == "button"){
      element.click();

      return;
    } else {
      element = getNextFocusElement(element, true);
    }
  // SHIFTキーが押下されている場合
  } else {
    element = getNextFocusElement(element, false);
  }

  try{
    // フォーカスを設定する
    setFocus( element.name );
  } catch(e) {
  }
}

/** コメントを表示 */
function showComment(visibility, element, event){
  var element_comment = getElementByName2(element.attributes.getNamedItem("name").nodeValue + "_comment");
  if(element_comment != null){
    element_comment.style.visibility = visibility;

    var left = 0;
    var top = 0;
    switch(browserType){
      // 
      case 0:
      case 2:
        left = event.x + document.body.scrollLeft;
        top = event.y + document.body.scrollTop;
        break;

      // 
      case 1:
        left = event.pageX;
        top = event.pageY;
        break;
    }

    element_comment.style.left = left;
    element_comment.style.top = top + 15;
  }
}

/** 入力必須項目の入力状態を検証 */
function checkEssentialItems(arrays){
  // 追加テーブルのElementを取得
  var elements_table = getDynamicTableElements();

  var str_error = "";
  var nRadio = 0;
  var array_radioInfos = new Array();

  var length_arrays = arrays.length;
  for(var ii = 0; ii < length_arrays; ii++){
    // 配列を取得
    var array = arrays[ii];
    var length_array = array.length;

    var nRepeat_max = 0;

    // Element配列を取得
    var elements = getElementsByName2( array[0] );
    if(elements == null){
      if(elements_table != null){
        var length_elements_table = elements_table.length;
        for(var jj = 0; jj < length_elements_table; jj++){
          var nRepeat = elements_table[jj].rows.length;
          if(nRepeat > nRepeat_max)
            nRepeat_max = nRepeat;
        }
      } else {
        continue;
      }

      elements = new Array();

      for(var jj = 0; jj < nRepeat_max; jj++){
        var name = array[0] + "_R_" + (jj + 1);

        var element = getElementByName2(name);
        if(element != null){
          // 
          if(element.type == "radio"){
            var elements2 = getElementsByName2(name);
            var length_elements2 = elements2.length;
            for(var kk = 0; kk < length_elements2; kk++)
              elements[ elements.length ] = elements2[kk];
          // 
          } else {
            elements[jj] = element;
          }
        } else {
          break;
        }
      }
    }

    var nElement = elements.length;
    for(var jj = 0; jj < nElement; jj++){
      var element = elements[jj];
      var name = element.name;

      // コンボボックス、リストの場合
      if(element.tagName == "SELECT"){
        var elements_select = new Array();
        var index = 0;

        // 選択項目を取得
        var length_options = element.options.length;
        for(var kk = 0; kk < length_options; kk++){
          if( element.options[kk].selected )
            elements_select[ index++ ] = element.options[kk].value;
        }

        var nMatch_select = 0;

        // 初期選択項目と比較
        var length_elements_select = elements_select.length;
        for(var kk = 0; kk < length_elements_select; kk++){
          for(var ll = 1; ll < length_array; ll++){
            if(elements_select[kk] == array[ll]){
              nMatch_select++;
              break;
            }
          }
        }

        if(length_elements_select == nMatch_select)
          str_error += name + "は入力必須項目です\r\n";
      } else {
        // チェックボックス場合
        if(element.type == "checkbox"){
          if((element.checked && array[1] == "true") || (!element.checked && array[1] == "false"))
            str_error += name + "は入力必須項目です\r\n";
        // ラジオボタンの場合
        } else if(element.type == "radio") {
          var isUpdate = false;

          // 変更がある場合
          if((element.checked && element.value != array[1]) || (!element.checked && element.value == array[1])){
            isUpdate = true;
          // 変更が無い場合
          } else {
          }

          var found = false;

          var length_array_radioInfos = array_radioInfos.length;
          for(var kk = 0; kk < length_array_radioInfos; kk++){
            var radioInfo = array_radioInfos[kk];
            if(radioInfo[0] == name){
              found = true;

              if( !radioInfo[1] )
                radioInfo[1] = isUpdate;
            }
          }

          // 登録
          if( !found ){
            var radioInfo = new Array();
            radioInfo[0] = name;
            radioInfo[1] = isUpdate;

            array_radioInfos[ nRadio++ ] = radioInfo;
          }

          if(jj == nElement - 1){
            var length_array_radioInfos = array_radioInfos.length;
            for(var kk = 0; kk < length_array_radioInfos; kk++){
              var radioInfo = array_radioInfos[kk];
              if( !radioInfo[1] )
                str_error += radioInfo[0] + "は入力必須項目です\r\n";
            }

            nRadio = 0;
            array_radioInfos = new Array();
          }
        // テキストフィールド、パスワードフィールド、テキストエリアの場合
        } else {
          if(array[1] == element.value)
            str_error += name + "は入力必須項目です\r\n";
        }
      }
    }
  }

  // エラーメッセージを表示
  if(str_error != ""){
    alert(str_error);

    return false;
  }

  return true;
}

/** 入力必須項目の入力状態を検証 */
function checkEssentialItems2(arrays){
  // 追加テーブルのElementを取得
  var elements_table = getDynamicTableElements();

  var nNames = 0;
  var array_names = new Array();
  var nRadio = 0;
  var array_radioInfos = new Array();

  var length_arrays = arrays.length;
  for(var ii = 0; ii < length_arrays; ii++){
    // 配列を取得
    var array = arrays[ii];
    var length_array = array.length;

    var nRepeat_max = 0;

    // Element配列を取得
    var elements = getElementsByName2( array[0] );
    if(elements == null){
      if(elements_table != null){
        var length_elements_table = elements_table.length;
        for(var jj = 0; jj < length_elements_table; jj++){
          var nRepeat = elements_table[jj].rows.length;
          if(nRepeat > nRepeat_max)
            nRepeat_max = nRepeat;
        }
      } else {
        continue;
      }

      elements = new Array();

      for(var jj = 0; jj < nRepeat_max; jj++){
        var name = array[0] + "_R_" + (jj + 1);

        var element = getElementByName2(name);
        if(element != null){
          // 
          if(element.type == "radio"){
            var elements2 = getElementsByName2(name);
            var length_elements2 = elements2.length;
            for(var kk = 0; kk < length_elements2; kk++)
              elements[ elements.length ] = elements2[kk];
          // 
          } else {
            elements[jj] = element;
          }
        } else {
          break;
        }
      }
    }

    var nElement = elements.length;
    for(var jj = 0; jj < nElement; jj++){
      var element = elements[jj];
      var name = element.name;

      // コンボボックス、リストの場合
      if(element.tagName == "SELECT"){
        var elements_select = new Array();
        var index = 0;

        // 選択項目を取得
        var length_options = element.options.length;
        for(var kk = 0; kk < length_options; kk++){
          if( element.options[kk].selected )
            elements_select[ index++ ] = element.options[kk].value;
        }

        var nMatch_select = 0;

        // 初期選択項目と比較
        var length_elements_select = elements_select.length;
        for(var kk = 0; kk < length_elements_select; kk++){
          for(var ll = 1; ll < length_array; ll++){
            if(elements_select[kk] == array[ll]){
              nMatch_select++;
              break;
            }
          }
        }

        if(length_elements_select == nMatch_select)
          array_names[ nNames++ ] = name;
      } else {
        // チェックボックス場合
        if(element.type == "checkbox"){
          if((element.checked && array[1] == "true") || (!element.checked && array[1] == "false"))
            array_names[ nNames++ ] = name;
        // ラジオボタンの場合
        } else if(element.type == "radio") {
          var isUpdate = false;

          // 変更がある場合
          if((element.checked && element.value != array[1]) || (!element.checked && element.value == array[1])){
            isUpdate = true;
          // 変更が無い場合
          } else {
          }

          var found = false;

          var length_array_radioInfos = array_radioInfos.length;
          for(var kk = 0; kk < length_array_radioInfos; kk++){
            var radioInfo = array_radioInfos[kk];
            if(radioInfo[0] == name){
              found = true;

              if( !radioInfo[1] )
                radioInfo[1] = isUpdate;
            }
          }

          // 登録
          if( !found ){
            var radioInfo = new Array();
            radioInfo[0] = name;
            radioInfo[1] = isUpdate;

            array_radioInfos[ nRadio++ ] = radioInfo;
          }

          if(jj == nElement - 1){
            var length_array_radioInfos = array_radioInfos.length;
            for(var kk = 0; kk < length_array_radioInfos; kk++){
              var radioInfo = array_radioInfos[kk];
              if( !radioInfo[1] )
                array_names[ nNames++ ] = radioInfo[0];
            }

            nRadio = 0;
            array_radioInfos = new Array();
          }
        // テキストフィールド、パスワードフィールド、テキストエリアの場合
        } else {
          if(array[1] == element.value)
            array_names[ nNames++ ] = name;
        }
      }
    }
  }

  return array_names;
}

/** 入力文字数を制限 */
function checkStringLength(element, maxLength, minLength){
  var value = element.value;
  var length_value = value.length;

  // 最大文字数を制限
  if(maxLength != 0 && length_value > maxLength){
    // エラーメッセージを表示
    alert(maxLength + "文字以上は入力出来ません");

    // 最大文字数以上の文字を削除
    element.value = value.substring(0, maxLength);

    // フォーカスを戻す
    element.focus();
  }

  // 最小文字数を制限
  if(minLength != 0 && length_value != 0 && length_value < minLength){
    // エラーメッセージを表示
    alert(minLength + "文字以上入力して下さい");

    // フォーカスを戻す
    element.focus();
  }
}

/** 値を検査 */
function checkValueType(checkType, element){
  var value = element.value;
  if(value == "")
    return;

  var str_error = "";

  switch(checkType){
    // 数字を検査
    case 1:{
      if( value.match(/[^0-9|.|,|\+|\-]/ig) )
        str_error = "半角数字を入力して下さい";

      break;
    }

    // 英字を検査
    case 2:{
      if( value.match(/[^a-z]/ig) )
        str_error = "半角英字を入力して下さい";

      break;
    }

    // 英数字を検査
    case 3:{
      if( value.match(/[^\w|.|,|\+|\-]/ig)  )
        str_error = "半角英数字を入力して下さい";

      break;
    }

    // 日付を検査
    case 4:{
      str_error = checkDate(value);
      break;
    }

    // URLを検査
    case 5:{
      str_error = checkURL(value);
      break;
    }

    // メールアドレスを検査
    case 6:{
      str_error = checkMailAddress(value);
      break;
    }
  }

  // 
  if(str_error.length > 0){
    // エラーメッセージを表示
    alert(str_error);

    // 値をクリア
    element.value = "";

    // フォーカスを戻す
    element.focus();
  }
}

/** 値を検査 */
function checkValueType2(checkType, element, maxValue, minValue, customRegExp, errorMessage){
  var value = element.value;
  if(value == "")
    return;

  var str_error = "";
  var alphabet_half  = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ'. ";
  var length_alphabet_half = alphabet_half.length;
  var alphabet_full  = "ａｂｃｄｅｆｇｈｉｊｋｌｍｎｏｐｑｒｓｔｕｖｗｘｙｚＡＢＣＤＥＦＧＨＩＪＫＬＭＮＯＰＱＲＳＴＵＶＷＸＹＺ’．　";
  var length_alphabet_full = alphabet_full.length;
  var number_half    = "0123456789.,-+\\$ ";
  var length_number_half = number_half.length;
  var number_full    = "０１２３４５６７８９．，－＋￥＄　";
  var length_number_full = number_full.length;
  var sign_half  = "!\\\"#$%&'()=~|`{+*}<>?_-^@[;:],./ ";
  var length_sign_half = sign_half.length;
  var sign_full  = "！￥”＃＄％＆’（）＝～｜‘｛＋＊｝＜＞？＿－＾＠［；：］，．／　";
  var length_sign_full = sign_full.length;
  var katakana_half  = "ｱｲｳｴｵｶｷｸｹｺｻｼｽｾｿﾀﾁﾂﾃﾄﾅﾆﾇﾈﾉﾊﾋﾌﾍﾎﾏﾐﾑﾒﾓﾔﾕﾖﾗﾘﾙﾚﾛﾜｦﾝｧｨｩｪｫｬｭｮｯｰ､｡ﾞﾟ ";
  var length_katakana_half = katakana_half.length;
  var katakana_half_special  = "ｶｷｸｹｺｻｼｽｾｿﾀﾁﾂﾃﾄﾊﾋﾌﾍﾎﾊﾋﾌﾍﾎ";
  var length_katakana_half_special = katakana_half_special.length;
  var katakana_full  = "アイウエオカキクケコサシスセソタチツテトナニヌネノハヒフヘホマミムメモヤユヨラリルレロワヲンァィゥェォャュョッー、。゛゜　ガギグゲゴザジズゼゾダヂヅデドバビブベボパピプペポ";
  var length_katakana_full = katakana_full.length;
  var hiragana       = "あいうえおかきくけこさしすせそたちつてとなにぬねのはひふへほまみむめもやゆよらりるれろわをんぁぃぅぇぉゃゅょっー、。゛゜　がぎぐげござじずぜぞだぢづでどばびぶべぼぱぴぷぺぽ";
  var length_hiragana = hiragana.length;
  var array_strs = new Array(alphabet_half, number_half, sign_half, katakana_half, alphabet_full, number_full, sign_full, katakana_full, hiragana);
  var length_array_strs = array_strs.length;

  // 半角から全角に変換
  if(checkType & 0x800){
    // 英字
    value = convertCharacter(value, alphabet_half, alphabet_full);
    // 数字
    value = convertCharacter(value, number_half, number_full);
    // 記号
    value = convertCharacter(value, sign_half, sign_full);

    // カタカナ
    var value2 = "";

    var length_value = value.length;
    for(var ii = 0; ii < length_value; ii++){
      var ch = value.charAt(ii);

      if(katakana_half_special.indexOf(ch) != -1){
        var index = katakana_half_special.indexOf(ch);
        if(ii < length_value - 1 && value.charAt(ii + 1) == "ﾞ"){
          index += 61;
          ii++;
          ch = katakana_full.charAt(index);
        } else if(ii < length_value - 1 && value.charAt(ii + 1) == "ﾟ") {
          index += 66;
          ii++;
          ch = katakana_full.charAt(index);
        } else {
          ch = katakana_full.charAt( katakana_half.indexOf(ch) );
        }
      } else {
        var index = katakana_half.indexOf(ch);
        if(index != -1)
          ch = katakana_full.charAt(index);
      }

      value2 += ch;
    }

    value = value2;

    element.value = value;
  }

  // 全角から半角に変換
  if(checkType & 0x1000){
    // 英字
    value = convertCharacter(value, alphabet_full, alphabet_half);
    // 数字
    value = convertCharacter(value, number_full, number_half);
    // 記号
    value = convertCharacter(value, sign_full, sign_half);

    // カタカナ
    var value2 = "";

    var length_value = value.length;
    for(var ii = 0; ii < length_value; ii++){
      var ch = value.charAt(ii);

      if(katakana_full.indexOf(ch) != -1){
        var index = katakana_full.indexOf(ch);
        if(index < length_katakana_half){
          ch = katakana_half.charAt( katakana_full.indexOf(ch) );
        } else {
          ch = katakana_half_special.charAt(index - 61);

          if(index < 81)
            ch += "ﾞ";
          else
            ch += "ﾟ";
        }
      }

      value2 += ch;
    }

    value = value2;

    element.value = value;
  }

  // 文字種を検査
  if(checkType & 0x3){
    // 半角、全角の両方をセットして半角英字、半角数字、半角カタカナ、全角英字、全角数字、ひらがな、全角カタカナの全てをセットしない場合
    if(((checkType & 0x1) && !(checkType & 0x3C)) && ((checkType & 0x2) && !(checkType & 0x7C0))){
    } else {
      var str_error_charType = "";
      var array_strs_charType = new Array("半角英字", "半角数字", "半角記号", "半角カタカナ", "半角英数", "全角英字", "全角数字", "全角記号", "全角カタカナ", "ひらがな", "全角英数");

      // エラーメッセージを作成
      var nCheck = 0;
      var nCheck_charType = 0;
      if((checkType & 0x3D) == 0x1){
        str_error_charType += "半角文字、";
        nCheck++;
        nCheck_charType++;
      }
      for(var ii = 0; ii < 4; ii++){
        // 半角英数の場合
        if(ii == 0 && (checkType & 0xC) == 0xC){
          str_error_charType += array_strs_charType[4] + "、";
          ii++;
          nCheck++;
          nCheck_charType += 2;
          continue;
        }

        if(checkType & (0x4 << ii)){
          str_error_charType += array_strs_charType[ii] + "、";
          nCheck++;
          nCheck_charType++;
        }
      }
      if((checkType & 0x7C2) == 0x2){
        str_error_charType += "全角文字、";
        nCheck++;
        nCheck_charType++;
      }
      for(var ii = 0; ii < 5; ii++){
        // 全角英数の場合
        if(ii == 0 && (checkType & 0xC0) == 0xC0){
          str_error_charType += array_strs_charType[10] + "、";
          ii++;
          nCheck++;
          nCheck_charType += 2;
          continue;
        }

        if(checkType & (0x40 << ii)){
          str_error_charType += array_strs_charType[ii + 5] + "、";
          nCheck++;
          nCheck_charType++;
        }
      }

      if(nCheck == 1)
        str_error_charType = str_error_charType.substring(0, str_error_charType.length - 1) + "で入力して下さい\r\n";
      else if(nCheck > 1)
        str_error_charType = str_error_charType.substring(0, str_error_charType.length - 1) + "のいずれかで入力して下さい\r\n";

      var isError_charType = false;

      // 使用文字種を調査
      var length_value = value.length;
      for(var ii = 0; ii < length_value; ii++){
        var ch = value.charAt(ii);
        var nNotFound = 0;

        for(var jj = 0; jj < 4; jj++){
          if(checkType & (0x4 << jj)){
            if(array_strs[jj].indexOf(ch) == -1)
              nNotFound++;
          }
        }

        for(var jj = 0; jj < 5; jj++){
          if(checkType & (0x40 << jj)){
            if(array_strs[jj + 4].indexOf(ch) == -1)
              nNotFound++;
          }
        }

        if(nCheck_charType == nNotFound)
          isError_charType = true;
      }

      // 半角文字チェック
      if(checkType == 0x1 && (getCharacterType(value) & 0x2))
        isError_charType = true;
      // 全角文字チェック
      if(checkType == 0x2 && (getCharacterType(value) & 0x1))
        isError_charType = true;

      if((checkType & 0x3D) == 0x1)
        checkType |= 0x3C;
      if((checkType & 0x7C2) == 0x2)
        checkType |= 0x7C0;

      // 最大値、最小値チェック
      if((checkType & 0x88) > 0 && (maxValue != null || minValue != null)){
        var value_number = convertCharacter(value, number_full, number_half);

        var str_error_numberLimit = checkNumberLimit(getNumber(value_number), maxValue, minValue);
        if(str_error_numberLimit.length > 0){
          isError_charType = false;
          str_error = str_error_numberLimit;
        }
      }

      // 
      if(isError_charType)
        str_error += str_error_charType;
    }
  }

  // 値タイプを検査
  if((checkType & 0xFE000) > 0){
    var isError_valueType = false;
    var str_error_valueType = "";
    var array_strs_valueType = new Array("日付", "時刻", "郵便番号", "電話番号", "電話番号（携帯）", "URL", "メールアドレス");
    var length_array_strs_valueType = array_strs_valueType.length;

    // エラーメッセージを作成
    var nCheck = 0;
    for(var ii = 0; ii < length_array_strs_valueType; ii++){
      if(checkType & (0x2000 << ii)){
        str_error_valueType += array_strs_valueType[ii] + "、";
        nCheck++;
      }
    }

    if(nCheck == 1)
      str_error_valueType = str_error_valueType.substring(0, str_error_valueType.length - 1) + "を入力して下さい\r\n";
    else if(nCheck > 1)
      str_error_valueType = str_error_valueType.substring(0, str_error_valueType.length - 1) + "のいずれかを入力して下さい\r\n";

    // 英字
    value = convertCharacter(value, alphabet_full, alphabet_half);
    // 数字
    value = convertCharacter(value, number_full, number_half);
    // 記号
    value = convertCharacter(value, sign_full, sign_half);

    var nError = 0;

    // 日付チェック
    if(checkType & 0x2000){
      var str_error_date = checkDate(value);
      if(str_error_date.length != 0)
        nError++;

      if(str_error_date != "日付を入力して下さい\r\n")
        str_error += str_error_date;
    }

    // 時刻チェック
    if(checkType & 0x4000){
      var str_error_time = checkTime(value);
      if(str_error_time.length != 0)
        nError++;

      if(str_error_time != "時刻を入力して下さい\r\n")
        str_error += str_error_time;
    }

    // 郵便番号チェック
    if(checkType & 0x8000){
      if( checkZipCode(value) )
        nError++;
    }

    // 電話番号チェック
    if(checkType & 0x10000){
      if( checkTelephoneNumber(value) )
        nError++;
    }

     // 電話番号（携帯）チェック
    if(checkType & 0x20000){
      if( checkMobilephoneNumber(value) )
        nError++;
    }

    // URLチェック
    if(checkType & 0x40000){
      if( checkURL(value) )
        nError++;
    }

    // メールアドレスチェック
    if(checkType & 0x80000){
      if( checkMailAddress(value) )
        nError++;
    }

    // 
    if(nCheck == nError)
      str_error += str_error_valueType;
  }

  // カスタム
  if(customRegExp != null && errorMessage != null)
    str_error += checkCustomRegExp(value, customRegExp, errorMessage);

  // 
  if(str_error.length > 0){
    // エラーメッセージを表示
    alert(str_error);

    // 値をクリア
    element.value = "";

    // フォーカスを戻す
    element.focus();
  }
}

/**  */
function getCharacterType(value){
  var type = 0;

  var length_value = value.length;
  for(var ii = 0; ii < length_value; ii++){
    var ch = value.charCodeAt(ii);

    // 半角
    if((ch >= 0x0 && ch < 0x81) || (ch >= 0xf8f0 && ch < 0xf8f4) || (ch >= 0xff61 && ch < 0xffa0))
      type |= 0x1;
    // 全角
    else
      type |= 0x2;
  }

  return type;
}

/**  */
function checkNumberLimit(value, maxValue, minValue){
  var str_error = "";

  // 最大値チェック
  if(maxValue != null){
    if(value > maxValue)
      str_error += "最大値（" + maxValue + "）より大きい値は入力出来ません\r\n";
  }
  // 最小値チェック
  if(minValue != null){
    if(value < minValue)
      str_error += "最小値（" + minValue + "）より小さい値は入力出来ません\r\n";
  }

  return str_error;
}

/** 半角文字と全角文字を変換する */
function convertCharacter(value, str1, str2){
  var value2 = "";

  var length_value = value.length;
  for(var ii = 0; ii < length_value; ii++){
    var ch = value.charAt(ii);

    if(str1.indexOf(ch) != -1)
      ch = str2.charAt( str1.indexOf(ch) );

    value2 += ch;
  }

  return value2;
}

/** 有効な日付かを検査 */
function checkDate(str_value){
  var str_error = "";

  // 入力値タイプを判定（0:文字列 1:数値 2:日付、時刻）
  var valueType = getValueType(str_value);
  if(valueType != 2){
    return "日付を入力して下さい\r\n";
  } else {
    year = null;
    month = null;
    day = null;

    getValue_daytime(str_value);
//alert(year + " : " + month + " : " + day);

    if(month == null || day == null)
      return "日付を入力して下さい\r\n";

    str_error = checkDate2(year, month, day);
  }

  return str_error;
}

/** 有効な時刻かを検査 */
function checkTime(str_value){
  var str_error = "";

  // 入力値タイプを判定（0:文字列 1:数値 2:日付、時刻）
  var valueType = getValueType(str_value);
  if(valueType != 2){
    return "時刻を入力して下さい\r\n";
  } else {
    hour = null;
    minute = null;
    second = null;

    getValue_daytime(str_value);
//alert(hour + " : " + minute + " : " + second);

    if(minute == null)
      return "時刻を入力して下さい\r\n";

    str_error = checkTime2(hour, minute, second);
  }

  return str_error;
}

/** 有効な郵便番号かを検査 */
function checkZipCode(str_value){
  var error = false;

  if( !str_value.match(/^\d{3}\d{4}$|^\d{3}-\d{4}$/) )
    error = true;

  return error;
}

/** 有効な電話番号かを検査 */
function checkTelephoneNumber(str_value){
  var error = false;

  if(!str_value.match(/^[0-9-]{6,9}$|^[0-9-]{10,12}$/) || (!str_value.match(/^\d{1,4}-\d{4}$|^\d{2,5}-\d{1,4}-\d{4}$/) && !str_value.match(/^\d{1,4}\d{4}$|^\d{2,5}\d{1,4}\d{4}$/)))
    error = true;

  return error;
}

/** 有効な電話番号（携帯）かを検査 */
function checkMobilephoneNumber(str_value){
  var error = false;

  if(!str_value.match(/^\d{3}-\d{4}-\d{4}$|^\d{11}$/) && !str_value.match(/^\d{3}\d{4}\d{4}$/))
    error = true;

  return error;
}

/** 有効なURLかを検査 */
function checkURL(str_value){
  var error = false;

  if(!str_value.match(/(http|https|ftp|mail):\/\/[!#-9A-~]+\.+[a-z0-9]+\.+[a-z0-9]+/i) && !str_value.match(/[!#-9A-~]+\.+[a-z0-9]+\.+[a-z0-9]+/i))
    error = true;

  return error;
}

/** 有効なメールアドレスかを検査 */
function checkMailAddress(str_value){
  var error = false;

  if( !str_value.match(/^([\w\_\-\.]+)@([\w\_\-\.]+\.[\w\_\-\.]+)$/) )
    return true;

  var userID = RegExp.$1;
  var domain = RegExp.$2;

  if(domain.match(/\.{2,}/) != null)
    return true;

  var userID_start = userID.charAt(0);
  var userID_end = userID.charAt(userID.length - 1);
  var domain_start = domain.charAt(0);
  var domain_end = domain.charAt(domain.length - 1);

  if(userID_start == "_" || userID_start == "-" || userID_start == "." || userID_end == "_" || userID_end == "-" || userID_end == "." || domain_start == "_" || domain_start == "-" || domain_start == "." || domain_end == "_" || domain_end == "-" || domain_end == ".")
    return true;

  return error;
}

/** カスタム検証 */
function checkCustomRegExp(str_value, customRegExp, str_error){
  if( !str_value.match(customRegExp) )
    return str_error;
  else
    return "";
}

/** 文字列にカンマを挿入 */
function insertComma2String(str_value){
  var str_integer = "";

  // 符号を保存
  var str_sign = "";
  if(str_value.charAt(0) == "+" || str_value.charAt(0) == "-")
    str_sign = str_value.charAt(0);

  // 半角数字、小数点以外の文字を削除
  var nDot = 0;
  var length_str = str_value.length;
  for(var ii = 0; ii < length_str; ii++){
    var ch = str_value.charAt(ii);
    if((ch >= "0" && ch <= "9") || ch == "."){
      // 小数点が複数の場合
      if(ch == "." && ++nDot > 1)
        continue;

      str_integer += ch;
    }
  }

  // 小数部分を取得
  var str_decimal = "";
  var index = str_integer.indexOf(".");
  if(index != -1){
    str_decimal = str_integer.substring(index);
    if(str_decimal == ".")
      str_decimal = "";

    // 小数部分を削除
    str_integer = str_integer.substring(0, index);
  }

  // カンマを挿入
  var str_comma = "";
  var length_str_integer = str_integer.length;
  for(var ii = 0; ii < length_str_integer; ii++){
    // ３桁毎にカンマを挿入
    if(ii > 0 && !((length_str_integer - ii) % 3))
      str_comma += ",";

    str_comma += str_integer.charAt(ii);
  }

  // 符号、整数、小数を合成
  return str_sign + str_comma + str_decimal;
}

/**
format_stx.js

function inputValue_format(element);
function convertValue_format(element, str_format);
function convertValues_format(array_names, array_strs_format);
function ChristianEra2JapaneseEra(year);
function JapaneseEra2ChristianEra(str_year);
function getJapaneseEraName(type, year);
function searchCode(str_code);
function parseFormatString(index, tokens_format);
function formatNumber(number, addDigit);

StraFormDesigner Ver1.5
Copyright(C) 2004-2008 FIT Corporation All Rights Reserved.

Last Update 2008/04/14
*/

/** 値を入力する場合 */
function inputValue_format(element){
  var name = element.name;

  // 隠しデータの値を取得
  var element_hidden4inputValue = getElementByName2(element.name + "_hidden4inputValue");
  if(element_hidden4inputValue != null)
    element.value = element_hidden4inputValue.value;

  // テキストフィールド、テキストエリアの場合、キャレットを移動する
  if((element.tagName == "INPUT" && element.type == "text") || element.tagName == "TEXTAREA")
    resetCaretPosition(element);
}

var valueType;
var formatType;
var tokens_format;
var str_inputValue;
var strs_code;
var style_color;
var styles_color_default = new Array();

var str_number;

/** フォーマットを適用する場合 */
function convertValue_format(element, str_format){
  str_format = str_format.replace(/\'+/ig, "\"");

  var name = element.name;

  // 
  var color_currentStyle;
  if(styles_color_default[name] == null){
    switch(browserType){
      // 
      case 0:
      case 2:
        color_currentStyle = element.currentStyle.color;
        break;

      // 
      case 1:
        color_currentStyle = getComputedStyle(element, "").getPropertyValue("color");
        break;
    }

    styles_color_default[name] = color_currentStyle;
  }

  // 入力値がフォーマット後の値と同じならば処理しない
  var element_hidden4formatted = getElementByName2(name + "_hidden4formatted");
  if(element_hidden4formatted != null){
    if(element_hidden4formatted.value == element.value)
      return;
  }

  // コード配列を初期化
  strs_code = new Array();
  // 入力値を保存
  var tagName = element.tagName;
  if(tagName == "INPUT" || tagName == "TEXTAREA")
    str_inputValue = element.value;
  else
    str_inputValue = getInnerHTML( element.innerHTML );

  var str_value = str_inputValue;

  // 値を隠しデータに保存
  setValue2Hidden(name, "_hidden4inputValue", str_value);

  if(str_value == ""){
    setValue2Hidden(name, "_hidden4formatted", "");

    return;
  }

  // 入力値を解析
  // 入力値の余分なスペースを削除
  str_value = str_value.replace(/\s+/ig, " ");
  // 入力値の先頭のスペースを削除
  if(str_value.indexOf(" ") == 0)
    str_value = str_value.substring(1, str_value.length);
  // 入力値の末尾のスペースを削除
  if(str_value.lastIndexOf(" ") == str_value.length - 1)
    str_value = str_value.substring(0, str_value.length - 1);

  // 入力値タイプを判定（0:文字列 1:数値 2:日付、時刻）
  valueType = getValueType(str_value);

  // 書式文字列を解析
  // 書式文字列の先頭のスペースを削除
  if(str_format.indexOf(" ") == 0)
    str_format = str_format.substring(1, str_format.length);
  // 書式文字列の末尾のスペースを削除
  if(str_format.lastIndexOf(" ") == str_format.length - 1)
    str_format = str_format.substring(0, str_format.length - 1);
  // 
  str_format = str_format.replace(/G\/標準+/ig, "[G/標準]");
  // 
  str_format = str_format.replace(/AM\/PM+/ig, "AMPM");
  str_format = str_format.replace(/A\/P+/ig, "AP");

  // 書式文字列の書式文字列を";"で分割
  var array_strs_format = str_format.split(";");
  var length_array_strs_format = array_strs_format.length;

  formatType = -1;
  var array_tokens_format = new Array();
  // 数値フォーマットで使用する文字列
  var tokens_format_number = new Array("0", "#", ",");
  var length_tokens_format_number = tokens_format_number.length;
  // 日付、時刻フォーマットで使用する文字列
  var tokens_format_daytime = new Array("yyyy", "yy", "ge", "gee", "gge", "ggee", "ggge", "gggee", "mmmmm", "mmmm", "mmm", "mm", "m", "aaaa", "aaa", "dddd", "ddd", "dd", "d", "hh", "h", "ss", "s", "AMPM", "AP");
  var length_tokens_format_daytime = tokens_format_daytime.length;
  // ダブルクオーテーションで囲む必要の無い特殊文字
  var tokens_special = new Array(" ", "$", "\\", "-", "+", "/", "(", ")", ":", "!", "^", "&", "`", "'", "~", "{", "}", "=", "<", ">", "%");
  var length_tokens_special = tokens_special.length;

  // フォーマットタイプを判定（0:文字列 1:数値 2:日付、時刻）
  for(var ii = 0; ii < length_array_strs_format; ii++){
    var str_format2 = array_strs_format[ii];

    var tokens_format2 = new Array();
    var index_format = 0;
    var dquato = false;
    var bracket = false;

    // 書式文字列を分割
    var length_str_format2 = str_format2.length;
    for(var jj = 0; jj < length_str_format2; jj++){
      var ch = str_format2.charAt(jj);

      if(!dquato && !bracket){
        // 特殊文字の場合
        for(var kk = 0; kk < length_tokens_special; kk++){
          if(ch == tokens_special[kk]){
            // 前の書式文字列を更新
            if(index_format != jj)
              tokens_format2[ tokens_format2.length ] = str_format2.substring(index_format, jj);

            tokens_format2[ tokens_format2.length ] = "\"" + ch + "\"";
            index_format = jj + 1;

            break;
          }
        }
      }

      // 最後の文字の場合
      if(jj == length_str_format2 - 1){
        if(index_format < jj + 1)
          tokens_format2[ tokens_format2.length ] = str_format2.substring(index_format, jj + 1);
      } else {
        // ダブルクオーテーションの場合
        if(ch == "\""){
          // 開始の場合
          if( !dquato ){
            // 前の書式文字列を更新
            if(index_format != jj)
              tokens_format2[ tokens_format2.length ] = str_format2.substring(index_format, jj);
            index_format = jj;

            dquato = true;
          // 終了の場合
          } else {
            dquato = false;

            tokens_format2[ tokens_format2.length ] = str_format2.substring(index_format, jj + 1);
            index_format = jj + 1;
          }
        // "["の場合
        } else if(ch == "[") {
          if( !dquato ){
            // 前の書式文字列を更新
            if(index_format != jj)
              tokens_format2[ tokens_format2.length ] = str_format2.substring(index_format, jj);
            index_format = jj;

            bracket = true;
          }
        // "]"の場合
        } else if(ch == "]") {
          if( !dquato ){
            bracket = false;

            tokens_format2[ tokens_format2.length ] = str_format2.substring(index_format, jj + 1);
            index_format = jj + 1;
          }
        }
      }
    }

    // 
    if(str_format2.indexOf("[G/標準]") != -1){
      // 
      var index = 0;
      var length_tokens_format2 = tokens_format2.length;
      for(var jj = 0; jj < length_tokens_format2; jj++){
        if(tokens_format2[jj] == "[G/標準]"){
          index = jj
          break;
        }
      }

      formatType = valueType;

      switch(formatType){
        // 文字列の場合
        case 0:{
          tokens_format2.splice(index, index, "[G/標準]", "@");
        }
        break;

        // 数値の場合
        case 1:{
          tokens_format2.splice(index, index, "[G/標準]", "0");
        }
        break;

        // 日付、時刻の場合
        case 2:{
          if(str_format2.indexOf("DBNum1") != -1 || str_format2.indexOf("DBNum2") != -1 ){
            formatType = 1;
            tokens_format2.splice(index, index, "[G/標準]", "0");
          } else {
            tokens_format2.splice(index, index, "[G/標準]", "yyyy", "\"/\"", "m", "\"/\"", "d");
          }
        }
        break;

      }
    }

    array_tokens_format[ii] = tokens_format2;

    // フォーマットタイプを判定（0:文字列 1:数値 2:日付、時刻）
    if(formatType == -1){
      formatType = 0;

      var length_tokens_format2 = tokens_format2.length;
      for(var jj = 0; jj < length_tokens_format2; jj++){
        var token_format2 = tokens_format2[jj];
        var first = token_format2.charAt(0);
        var end = token_format2.charAt(token_format2.length - 1);

        // ダブルクオーテーション、"[]"で囲まれていない場合
        if((first != "\"" && end != "\"") && (first != "[" && end != "]")){
          // 数値フォーマットで使用する文字列と比較
          for(var kk = 0; kk < length_tokens_format_number; kk++){
            if(token_format2.indexOf( tokens_format_number[kk] ) != -1){
              formatType = 1;
              break;
            }
          }

          // 日付、時刻フォーマットで使用する文字列と比較
          for(var kk = 0; kk < length_tokens_format_daytime; kk++){
            if(token_format2.indexOf( tokens_format_daytime[kk] ) != -1){
              formatType = 2;
              break;
            }
          }
        }
      }
    }
  }

  tokens_format = new Array();

  var number_digit = 0;
  var number_decimal = 0.0;
  var number_double = 0.0;

  year = 1900;
  month = 1;
  day = 1;
  hour = 0;
  hour_org = 0;
  minute = 0;
  second = 0;

  // フォーマットタイプと入力値タイプが異なる場合、値を変換
  switch(formatType){
    // 文字列の場合
    case 0:{
      valueType = 0;

      str_format = array_strs_format[length_array_strs_format - 1];
      tokens_format = array_tokens_format[length_array_strs_format - 1];
    }
    break;

    // 数値の場合
    case 1:{
      // 
      switch(valueType){
        // 文字列の場合
        case 0:{
          formatType = 0;

          str_format = "@";
          tokens_format = new Array("@");
        }
        break;

        // 数値の場合
        case 1:{
          number_double = getNumber(str_value);

          // 書式を選択
          // 正の場合
          if(number_double > 0){
            str_format = array_strs_format[0];
            tokens_format = array_tokens_format[0];
          // 0の場合
          } else if(number_double == 0) {
            switch(length_array_strs_format){
              case 1:
              case 2:
                str_format = array_strs_format[0];
                tokens_format = array_tokens_format[0];
                break;

              case 4:
                str_format = array_strs_format[2];
                tokens_format = array_tokens_format[2];
                break;
            }
          // 負の場合
          } else if(number_double < 0) {
            switch(length_array_strs_format){
              case 1:
                str_format = array_strs_format[0];
                tokens_format = array_tokens_format[0];
                break;

              case 2:
              case 4:
                str_format = array_strs_format[1];
                tokens_format = array_tokens_format[1];
                break;
            }
          }
        }
        break;

        // 日付、時刻の場合
        case 2:{
          valueType = 1;

          getValue_daytime(str_value);

          if(year == 0 || month == 0 || day == 0){
            formatType = 0;

            str_format = "@";
            tokens_format = new Array("@");
          } else {
            // 日付を数値に変換
            number_double = (year - 1900) * 365 + month * 12 + day;
            str_value = number_double.toString();

            str_format = array_strs_format[0];
            tokens_format = array_tokens_format[0];
          }
        }
        break;
      }
    }
    break;

    // 日付、時刻の場合
    case 2:{
      str_format = array_strs_format[0];
      tokens_format = array_tokens_format[0];

      switch(valueType){
        // 文字列の場合
        case 0:{
          formatType = 0;

          str_format = "@";
          tokens_format = new Array("@");
        }
        break;

        // 数値の場合
        case 1:{
          valueType = 2;

          number_digit = getNumber(str_value);

          // 数値を日付に変換
          var year2 = parseInt(number_digit / 365);
          number_digit -= year2 * 365;
          year = 1900 + year2;
          var month2 = parseInt(number_digit / 31);
          number_digit -= month2 * 31;
          month = 1 + month2;
          day = 1 + number_digit;
        }
        break;
      }
    }
    break;
  }

  // 日付、時間の場合
  if(formatType == 2){
    // フォーマット文字列を“.”で区切る
    var tokens_format2 = new Array();

    // 
    var length_tokens_format = tokens_format.length;
    for(var ii = 0; ii < length_tokens_format; ii++){
      var index_token = 0;
      var token_format = tokens_format[ii];

      var length_token_format = token_format.length;
      for(var jj = 0; jj < length_token_format; jj++){
        var ch = token_format.charAt(jj);

        // "."
        if(ch == "."){
          tokens_format2[ tokens_format2.length ] = token_format.substring(index_token, jj);
          tokens_format2[ tokens_format2.length ] = "\".\"";
          index_token = jj + 1;
        // 最後の文字の場合
        } else if(jj == length_token_format - 1) {
          tokens_format2[ tokens_format2.length ] = token_format.substring(index_token, jj + 1);
        }
      }
    }

    // フォーマット文字列を更新する
    tokens_format = tokens_format2;
    tokens_format2 = new Array();

    // 
    var length_tokens_format = tokens_format.length;
    for(var ii = 0; ii < length_tokens_format; ii++){
      var token_format = tokens_format[ii];
      var first = token_format.charAt(0);
      var end = token_format.charAt(token_format.length - 1);

      if((first == "\"" && end == "\"") || (first == "[" && end == "]")){
        tokens_format2[ tokens_format2.length ] = token_format;
      } else {
        var ch_old = "";
        var index_token = 0;

        var length_token_format = token_format.length;
        for(var jj = 0; jj < length_token_format; jj++){
          var token = token_format.substring(index_token, jj);
          var ch = token_format.charAt(jj);

          // 最後の文字の場合
          if(jj == length_token_format - 1){
            tokens_format2[ tokens_format2.length ] = token_format.substring(index_token, jj + 1);
          } else {
            // 
            for(var kk = 0; kk < length_tokens_format_daytime; kk++){
              if(token == tokens_format_daytime[kk]){
                if(ch != ch_old){
                  tokens_format2[ tokens_format2.length ] = token_format.substring(index_token, jj);
                  index_token = jj;

                  break;
                }
              }
            }
          }

          ch_old = ch;
        }
      }
    }

    tokens_format = tokens_format2;
  }

  var str_formattedValue = "";

  // 各フォーマットタイプの書式処理（前処理）
  switch(formatType){
    // 文字列の場合
    case 0:{
    }
    break;

    // 数値の場合
    case 1:{
      str_number = "";

      var isMinus = false;
      var nComma = 0;
      var isComma = false;
      var isDecimal = false;
      var nDigit_min = 0;
      var nDecimal_min = 0;
      var nDecimal_max = 0;

      var length_str_format = str_format.length;
      for(var ii = 0; ii < length_str_format; ii++){
        var ch = str_format.charAt(ii);

        // ","
        if(ch == ","){
          nComma++;
          isComma = true;
        // "."
        } else if(ch == ".") {
          isDecimal = true;
        // "#" "0"
        } else if(ch == "#" || ch == "0") {
          nComma = 0;

          // 小数の場合
          if(isDecimal){
            if(ch == "0")
              nDecimal_min++;
            nDecimal_max++;
          // 整数の場合
          } else {
            if(ch == "0")
              nDigit_min++;
          }
        }
      }

      // カンマ数分桁を削除
      if(nComma > 0)
        number_double /= Math.pow(1000, nComma);

      // 四捨五入
      number_double = round(number_double, nDecimal_max + 1);

      // 整数部分と小数部分に分割
      var str_number_double = number_double.toString();
      number_digit = parseInt( str_number_double );
      var index_dot = str_number_double.indexOf(".");
      if(index_dot != -1)
        number_decimal = parseFloat( str_number_double.substring(index_dot, str_number_double.length) );

      // 負
      if(number_double < 0.0){
        number_digit *= -1;
        isMinus = true;
      }

      var str_number_digit = number_digit.toString();

      // 整数部分の桁数を調整
      var length_str_number_digit = str_number_digit.length;
      for(var ii = length_str_number_digit; ii < nDigit_min; ii++)
        str_number_digit = "0" + str_number_digit;

      // 整数部分にカンマを挿入
      if(isComma){
        length_str_number_digit = str_number_digit.length;
        for(var ii = 0; ii < length_str_number_digit; ii++){
          // ３桁毎にカンマを挿入
          if(ii > 0 && !((length_str_number_digit - ii) % 3))
            str_number += ",";

          str_number += str_number_digit.charAt(ii);
        }
      } else {
        str_number = str_number_digit;
      }

      // 小数部分の桁数を調整
      var str_number_decimal = number_decimal.toString();
      str_number_decimal = str_number_decimal.substring(2, str_number_decimal.length);

      var length_str_number_decimal = str_number_decimal.length;
      for(var ii = length_str_number_decimal; ii < nDecimal_min; ii++)
        str_number_decimal += "0";

      if(nDecimal_max != 0 && str_number_decimal.length > nDecimal_max)
        str_number_decimal = str_number_decimal.substring(0, nDecimal_max);

      // 小数部分を結合
      if(str_number_decimal.length > 0)
        str_number += "." + str_number_decimal;

      if(isMinus && length_array_strs_format == 1)
        str_number = "-" + str_number;
    }
    break;

    // 日付、時刻の場合
    case 2:{
      getValue_daytime(str_value);
    }
    break;
  }

  // 
  if(styles_color_default[name] != null)
    style_color = styles_color_default[name];

  year_org = year;

  // 書式処理
  var length_tokens_format = tokens_format.length;
  for(var ii = 0; ii < length_tokens_format; ii++)
    str_formattedValue += parseFormatString(ii, tokens_format);

  element.style.color = style_color;

  // フォーマットされない場合、入力値を戻す
  if(str_formattedValue.length == 0)
    str_formattedValue = str_inputValue;

  // 値を設定
  setValue(element, str_formattedValue);

  // 値を隠しデータに保存
  setValue2Hidden(name, "_hidden4formatted", str_formattedValue);

  // 入力値を隠しデータに保存
  var element_hidden4inputValue = getElementByName2(name + "_hidden4inputValue");
  if(element_hidden4inputValue != null && element_hidden4inputValue.value != str_inputValue)
    element_hidden4inputValue.value = str_inputValue;
}

/**  */
function convertValues_format(array_names, array_strs_format){
  // 追加テーブルのElementを取得
  var elements_table = getDynamicTableElements();

  var length_array_names = array_names.length;
  for(var ii = 0; ii < length_array_names; ii++){
    var name = array_names[ii];
    var str_format = array_strs_format[ii].replace(/\'+/ig, "\"");

    // Elementを取得
    var element = getElementByName2(name);
    if(element == null){
      // 
      if(elements_table != null){
        var length_elements_table = elements_table.length;
        for(var jj = 0; jj < length_elements_table; jj++){
          var element_table = elements_table[jj];
          if(element_table != null){
            // 
            var nRepeat = element_table.rows.length;
            for(var kk = 0; kk < nRepeat; kk++){
              var element_repeat = getElementByName2(name + "_R_" + (kk + 1));
              if(element_repeat != null)
                convertValue_format(element_repeat, str_format);
            }
          } else {
            continue;
          }
        }
      }
    } else {
      convertValue_format(element, str_format);
    }
  }
}

/**  */
function ChristianEra2JapaneseEra(year){
  // 平成
  if(year > 1988)
    return year - 1988;
  // 昭和
  else if(year > 1925)
    return year - 1925;
  // 大正
  else if(year > 1911)
    return year - 1911;
  // 明治
  else if(year > 1867)
    return year - 1867;
  // エラー
  else
    return 0;
}

/**  */
function JapaneseEra2ChristianEra(str_year){
  var eraName = str_year.charAt(0).toUpperCase();
  var year = eval( str_year.substring(1, str_year.length) );

  // 平成
  if((eraName == "H") && (year > 0))
    return 1988 + year;
  // 昭和
  else if((eraName == "S") && (year > 0) && (year < 65))
    return 1925 + year;
  // 大正
  else if((eraName == "T") && (year > 0) && (year < 16))
    return 1911 + year;
  // 明治
  else if((eraName == "M") && (year > 0) && (year < 46))
    return 1867 + year;
  // エラー
  else
    return 0;
}

/**  */
function getJapaneseEraName(type, year){
  // 平成
  if(year > 1988){
    if(type == 1)
      return "H";
    else
      return "平成";
  // 昭和
  } else if(year > 1925) {
    if(type == 1)
      return "S";
    else
      return "昭和";
  // 大正
  } else if(year > 1911) {
    if(type == 1)
      return "T";
    else
      return "大正";
  // 明治
  } else if(year > 1867) {
    if(type == 1)
      return "M";
    else
      return "明治";
  // エラー
  } else {
    return "";
  }
}

/**  */
function searchCode(str_code){
  var length_strs_code = strs_code.length;
  for(var ii = 0; ii < length_strs_code; ii++){
    if(strs_code[ii] == str_code)
      return true;
  }

  return false;
}

/** 書式文字列の解析 */
function parseFormatString(index, tokens_format){
  var token_format = tokens_format[index];
  var str_formattedValue = "";

  var mmmm = new Array("January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December");
  var aaaa = new Array("日曜日", "月曜日", "火曜日", "水曜日", "木曜日", "金曜日", "土曜日");
  var ddd = new Array("Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday");

  // @
  if(token_format == "@"){
    str_formattedValue += str_inputValue;
  // 1900
  } else if(token_format == "yyyy") {
    str_formattedValue += formatNumber(year, false);
  // 00
  } else if(token_format == "yy") {
    year = year % 100;
    if(year < 10)
      year = "0" + year;
    str_formattedValue += formatNumber(year, true);
  // H7 H07
  } else if(token_format == "ge" || token_format == "gee") {
    str_formattedValue += getJapaneseEraName(1, year);
    var JapaneseEra = ChristianEra2JapaneseEra(year);
    if(token_format == "gee" && JapaneseEra < 10)
      str_formattedValue += "0";
    str_formattedValue += formatNumber(JapaneseEra, true);
  // 平7 平07
  } else if(token_format == "gge" || token_format == "ggee") {
    str_formattedValue += getJapaneseEraName(2, year).chatAt(0);
    var JapaneseEra = ChristianEra2JapaneseEra(year);
    if(token_format == "ggee" && JapaneseEra < 10)
      str_formattedValue += "0";
    str_formattedValue += formatNumber(JapaneseEra, true);
  // 平成7
  } else if(token_format == "ggge" || token_format == "gggee") {
    str_formattedValue += getJapaneseEraName(2, year);
    var JapaneseEra = ChristianEra2JapaneseEra(year);
    if(token_format == "gggee" && JapaneseEra < 10)
      str_formattedValue += "0";
    str_formattedValue += formatNumber(JapaneseEra, true);
  // J
  } else if(token_format == "mmmmm") {
    str_formattedValue += mmmm[month - 1].charAt(0);
  // January
  } else if(token_format == "mmmm") {
    str_formattedValue += mmmm[month - 1];
  // Jan
  } else if(token_format == "mmm") {
    str_formattedValue += mmmm[month - 1].substring(0, 3);
  // 01 12
  // 00 59
  // 1 12
  // 0 59
  } else if(token_format == "m" || token_format == "mm") {
    var type = -1;
    var array_days = new Array("yyyy", "yy", "ge", "gee", "gge", "ggee", "ggge", "gggee", "dd", "d");
    var array_times = new Array("h", "hh", "s", "ss");

    // 月か分か判定
    for(var ii = index - 1; ii >= 0; ii--){
      if(type == -1){
        for(var jj = 0; jj < 10; jj++){
          if(tokens_format[ii] == array_days[jj]){
            type = 0;
            break;
          }
        }
      }

      if(type == -1){
        for(var jj = 0; jj < 4; jj++){
          if(tokens_format[ii] == array_times[jj]){
            type = 1;
            break;
          }
        }
      }
    }
    var length_tokens_format = tokens_format.length;
    for(var ii = index + 1; ii < length_tokens_format; ii++){
      if(type == -1){
        for(var jj = 0; jj < 10; jj++){
          if(tokens_format[ii] == array_days[jj]){
            type = 0;
            break;
          }
        }
      }

      if(type == -1){
        for(var jj = 0; jj < 4; jj++){
          if(tokens_format[ii] == array_times[jj]){
            type = 1;
            break;
          }
        }
      }
    }

    switch(type){
      // 月
      case 0:{
        if(token_format == "mm" && month < 10)
          month = "0" + month;
        str_formattedValue += formatNumber(month, true);
      }
      break;

      // 分
      case 1:{
        if(token_format == "mm" && minute < 10)
          minute = "0" + minute;
        str_formattedValue += formatNumber(minute, true);
      }
      break;
    }
  // 日曜日 日
  } else if(token_format == "aaaa" || token_format == "aaa") {
    var date = new Date(year_org, month - 1, day);
    var str_date = aaaa[ date.getDay() ];
    if(token_format == "aaa")
      str_formattedValue += str_date.charAt(0);
    else
      str_formattedValue += str_date;
  // Sunday Sun
  } else if(token_format == "dddd" || token_format == "ddd") {
    var date = new Date(year_org, month - 1, day);
    var str_date = ddd[ date.getDay() ];
    if(token_format == "ddd")
      str_formattedValue += str_date.substring(0, 3);
    else
      str_formattedValue += str_date;
  // 01 31 1 31
  } else if(token_format == "dd" || token_format == "d") {
    if(token_format == "dd" && day < 10)
      day = "0" + day;
    str_formattedValue += formatNumber(day, true);
  // 00 23 0 23
  } else if(token_format == "hh" || token_format == "h") {
    if( searchCode("$-409") ){
      if(hour > 12)
        hour -= 12;
    }

    if(token_format == "hh" && hour < 10)
      hour = "0" + hour;
    str_formattedValue += formatNumber(hour, true);
  // 00 59 0 59
  } else if(token_format == "ss" || token_format == "s") {
    if(token_format == "ss" && second < 10)
      second = "0" + second;
    str_formattedValue += formatNumber(second, true);
  // 午前 午後
  } else if(token_format == "AMPM" || token_format == "AP") {
    if(hour_org <= 12)
      str_formattedValue += "AM";
    else
      str_formattedValue += "PM";
  // その他
  } else {
    var length_token_format = token_format.length;

    // "[]"で囲まれた文字列
    if(token_format.charAt(0) == "[" && token_format.charAt(length_token_format - 1) == "]"){
      var strs_color = new Array("黒", "青", "水", "緑", "紫", "赤", "白", "黄");
      var strs_style_color = new Array("black", "blue", "aqua", "green", "purple", "red", "white", "yellow");

      var str_code = token_format.substring(1, length_token_format - 1);
      strs_code.push(str_code);

      for(var ii = 0; ii < 8; ii++){
        if(str_code == strs_color[ii]){
          style_color = strs_style_color[ii];
          break;
        }
      }
    // ダブルクオーテーションで囲まれた文字列
    } else if(token_format.charAt(0) == "\"" && token_format.charAt(length_token_format - 1) == "\"") {
      str_formattedValue += token_format.substring(1, length_token_format - 1);
    // 
    } else {
      if(formatType == 1)
        str_formattedValue += formatNumber(str_number, false);

      // "?"数分のスペースを挿入
      for(var ii = length_token_format; ii >= 0; ii--){
        if(token_format.charAt(ii) == "?")
          str_formattedValue += " ";
      }
    }
  }

  return str_formattedValue;
}

/**  */
function formatNumber(number, addDigit){
  if(number == null)
    return;

  var str_formatted = "";
  var str_number = number.toString();
  var length_str_number = str_number.length;
  var DBNum1 = new Array("〇", "一", "二", "三", "四", "五", "六", "七", "八", "九");
  var DBNum2 = new Array("〇", "壱", "弐", "参", "四", "伍", "六", "七", "八", "九");
  var DBNum3 = new Array("０", "１", "２", "３", "４", "５", "６", "７", "８", "９");
  var normal = new Array("0", "1", "2", "3", "4", "5", "6", "7", "8", "9");
  var array_numbers;
  var digits_DBNum1 = new Array("", "十", "百", "千", "", "十", "百", "千", "", "十", "百", "千", "", "十", "百", "千");
  var digits_DBNum2 = new Array("", "拾", "百", "阡", "", "拾", "百", "阡", "", "拾", "百", "阡", "", "拾", "百", "阡");
  var array_digits = null;
  var units_DBNum1 = new Array("", "万", "億", "兆");
  var units_DBNum2 = new Array("", "萬", "億", "兆");
  var array_units = null;
  var array_onlyDigit = new Array(1, 2, 3, 5, 6, 7, 9, 10, 11, 13, 14, 15);
  var length_array_onlyDigit = array_onlyDigit.length;
  var code = 0;

  if( searchCode("DBNum1") ){
    array_numbers = DBNum1;
    array_digits = digits_DBNum1;
    array_units = units_DBNum1;
    code = 0x1;
  } else if( searchCode("DBNum2") ) {
    array_numbers = DBNum2;
    array_digits = digits_DBNum2;
    array_units = units_DBNum2;
    code = 0x2;
  } else if( searchCode("DBNum3") ) {
    array_numbers = DBNum3;
    code = 0x4;
  } else {
    array_numbers = normal;
  }

  if( searchCode("G/標準") )
    code |= 0x10;

  if(code == 0x11 || code == 0x12){
    addDigit = true;
  } else {
    if(code != 0x1 && code != 0x2)
      addDigit = false;
  }

  // 整数の桁を取得
  var nDigit = 0;
  for(var ii = 0; ii < length_str_number; ii++){
    var ch = str_number.charAt(ii);
    if(ch == ".")
      break;

    if( !isNaN( Number(ch) ) )
      nDigit++;
  }

  var setUnit = false;
  var zero = false;
  if(parseInt(number) == 0)
    zero = true;

  for(var ii = 0; ii < length_str_number; ii++){
    var ch = str_number.charAt(ii);

    // 数値ではない場合
    if( isNaN( Number(ch) ) ){
      str_formatted += ch;

      // 小数点の場合
      if(ch == ".")
        addDigit = false;

      continue;
    }

    // 桁を表示
    if(addDigit){
      var index = nDigit - ii - 1;

      if(ch != "0"){
        var addNumber = true;
        if((code & 0x01) && ch == "1"){
          for(var jj = 0; jj < length_array_onlyDigit; jj++){
            if(index == array_onlyDigit[jj]){
              addNumber = false;

              if(index >= 5)
                setUnit = true;

              break;
            }
          }
        }

        // 数字を表示
        if(addNumber){
          str_formatted += array_numbers[ eval(ch) ];
          setUnit = true;
        }

        // 単位を表示
        str_formatted += array_digits[index];
      } else if(zero) {
        str_formatted += array_numbers[ eval(ch) ];
      }

      if(setUnit){
        if(array_units != null && (index % 4) == 0){
          str_formatted += array_units[ parseInt(index / 4) ];
          setUnit = false;
        }
      }
    } else {
      str_formatted += array_numbers[ eval(ch) ];
    }
  }

  return str_formatted;
}

/**
action_stx.js

function startTimer();
function updateTimer();
function checkKeyCode(event, useCode, code, useSHIFT, isSHIFT, useCTRL, isCTRL, useALT, isALT);
function checkCondition(type, names, values);
function getURLBase(url);
function isReferenceForm();
function post(url);
function post2(url);
function checkSubmitted();
function calculate(element, calcType, itemType, names_value, name_target);
function calculateAverage(names);
function calculateMax(names);
function calculateMin(names);
function linkToURL(popup, href, width, height);
function setAttribute4Component(attributes, names);
function createPopup(url, title, x, y, width, height);
function calendar(nMonth, startType, name, str_format, arg1, arg2);
function showClock(name, reload);
function updateClock(name, reload);
function resetCaretPosition(element);
function setFocus(name);
function isRegistInCookie(key);
function setValue2Cookie(key, value);
function getValueFromCookie(key);
function setValue2UserData(element, key, value);
function getValueFromUserData(element, key);
function removeValueFromUserData(element, key);
function isRegistInUserData(element, key);
function isSelectedElement(name, elements);
function saveFormData(isAll, elements);
function getFormData(isAll, elements);
function deleteFormData(isAll, elements);
function deletePostData();
function setValue2Opener(names_child, name_parent);
function setValues2Opener(names_child, names_parent);
function showPopup4Image(src, magnifyRate_w, magnifyRate_h, fit, width, height);
function addRowDynamically(element, type, tableID, pos);
function deleteRowDynamically(element, tableID);
function getItemValue(element);
function isInputtedItem(element);
function deleteTable(isRow, type, name_table, elements);
function deleteRowByValue(table, name);
function deleteColumnByValue(table, name);
function deleteRowCompulsorily(table, indices);
function deleteColumnCompulsorily(table, indices);

StraFormDesigner Ver1.5
Copyright(C) 2004-2008 FIT Corporation All Rights Reserved.

Last Update 2008/04/14
*/

var timerID;
var timer = 0;

/** タイマーを作成 */
function startTimer(){
  clearTimeout(timerID);

  // 1秒毎にupdateTimerを呼び出す
  timerID = setInterval("updateTimer()", 1000);
}

/** タイマーを更新 */
function updateTimer(){
  timer++;
}

/** キーコードを検証 */
function checkKeyCode(event, useCode, code, useSHIFT, isSHIFT, useCTRL, isCTRL, useALT, isALT){
  // Windows以外の場合、Enterキーのキーコードを変更
  if(code == 0x0A && navigator.platform.indexOf("Win") != -1){
    code = 0x0D;
  } else {
    var array_codes = new Array(155, 127);
    var length_array_codes = array_codes.length;
    var array_codes2 = new Array(45, 46);

    for(var ii = 0; ii < length_array_codes; ii++){
      if(code == array_codes[ii]){
        code = array_codes2[ii];
        break;
      }
    }
  }

  // キーコードを変換
  var keyCode;
  switch(browserType){
    // 
    case 0:
    case 2:
      keyCode = event.keyCode;
      break;

    // 
    case 1:
      keyCode = (event.keyCode != 0) ? event.keyCode : event.charCode;
      break;
  }

  // キー
  if(useCode && code != keyCode)
    return false;

  // SHIFTキー
  if(useSHIFT){
    if(isSHIFT != event.shiftKey)
      return false;
  }

  // CTRLキー
  if(useCTRL){
    if(isCTRL != event.ctrlKey)
      return false;
  }

  // ALTキー
  if(useALT){
    if(isALT != event.altKey)
      return false;
  }

  return true;
}

/** 条件を検証 */
function checkCondition(type, names, values){
  var length_names = 0;
  if(names != null)
    length_names = names.length;

  // 条件タイプ
  switch(type){
    // 数値
    case 0:
      var conditionValue = values[0];
      if(conditionValue == "")
        conditionValue = 0;

      for(var ii = 0; ii < length_names; ii++){
        var value = getValueByName( names[ii] );
        value = getNumber(value);

        // 
        switch( values[1] ){
          // 等しい
          case 0:{
            if(value != conditionValue)
              return false;
          }
          break;

          // 等しくない
          case 1:{
            if(value == conditionValue)
              return false;
          }
          break;

          // より上
          case 2:{
            if(value <= conditionValue)
              return false;
          }
          break;

          // より下
          case 3:{
            if(value >= conditionValue)
              return false;
          }
          break;

          // 以上
          case 4:{
            if(value < conditionValue)
              return false;
          }
          break;

          // 以下
          case 5:{
            if(value > conditionValue)
              return false;
          }
          break;
        }
      }
      break;

    // 文字列
    case 1:{
      var conditionValue = values[0];

      for(var ii = 0; ii < length_names; ii++){
        var value = getValueByName( names[ii] );

        // 
        switch( values[1] ){
          // 等しい
          case 0:{
            if(value != conditionValue)
              return false;
          }
          break;

          // 等しくない
          case 1:{
            if(value == conditionValue)
              return false;
          }
          break;
        }
      }
    }
    break;

    // タイマー
    case 2:{
      var conditionValue = values[0];

      // 
      switch( values[1] ){
        // より前
        case 0:{
          if(timer >= conditionValue)
            return false;
        }
        break;

        // 後
        case 1:{
          if(timer != conditionValue)
            return false;
        }
        break;

        // より後
        case 2:{
          if(timer <= conditionValue)
            return false;
        }
        break;
      }
    }
    break;
  }

  return true;
}

/** 現在のページのURLからベースURLを作成して、POST先アドレスを生成 */
function getURLBase(url){
  var base = location.protocol + "//" + location.host;
  var path = location.pathname;

  if(url.indexOf(base) == -1){
    var index = path.indexOf("/", 1);
    if(index != -1)
      path = path.substring(0, index + 1);

    return base + path + url;
  } else {
    return url;
  }
}

/** 参照用フォームか検証 */
function isReferenceForm(){
  var search = location.search;
  var requests = search.substring(1, search.length).split("&");
  var isReference = false;

  // クエリ文字列から“responseType”を検索
  var length_requests = requests.length;
  for(var ii = 0; ii < length_requests; ii++){
    var map = requests[ii].split("=");

    // 参照用フォームの場合
    if(map[0] == "responseType" && map[1] == "REFERENCE")
      isReference = true;
  }

  return isReference;
}

var unlockFormFlag = true;

/** データを送信 */
function post(url){
  // 入力用フォームの場合
  if( !isReferenceForm() ){
    // フォーマット設定で“送信する値”を“入力値”に設定しているアイテムの配列
    var array_names_hidden4post = getElementByName2("array_names_hidden4format");
    var array_names = null;
    var length_array_names = 0;

    if(array_names_hidden4post != null){
      array_names = eval( array_names_hidden4post.value );
      length_array_names = array_names.length;
    }

    var isInDynamicTable = false;
    var elements_table = getDynamicTableElements();
    var length_elements_table;
    if(elements_table != null)
      length_elements_table = elements_table.length;
    var all = getFormElements( document.form );

    // 
    var nElement = all.length;
    for(var ii = 0; ii < nElement; ii++){
      var element = all[ii];
      var name = element.name;
      if(name == null)
        continue;

      // 無効の場合、disabled属性をクリアする
      if( element.disabled )
        element.disabled = false;

      // 入力時に“テーブル行、列を削除”を実行した場合、削除されたセル内のアイテムの値を送信する
      var index_hidden4post = name.indexOf("_hidden4post");
      if(index_hidden4post > 0)
        element.name = name.substring(0, index_hidden4post);

      // アイテム名から“_R_”を削除
      var name2 = name;
      var index_repeat = name.indexOf("_R_");
      if(index_repeat > 0 && elements_table != null){
        if(element.type != "hidden"){
          var element2 = element;
          if( !isInDynamicTable ){
            // 追加テーブル内のアイテムか判定
            while(true){
              if(element2 == null || element2.tagName == "FORM")
                break;

              if(element2.tagName == "TABLE"){
                for(var jj = 0; jj < length_elements_table; jj++){
                  if(elements_table[jj].name == element2.name){
                    isInDynamicTable = true;
                    break;
                  }
                }

                break;
              }

              element2 = element2.parentNode;
            }
          }

          if(isInDynamicTable)
            name2 = name.substring(0, index_repeat);
        }
      } else {
        isInDynamicTable = false;
      }

      // フォーマット設定しているアイテムの値に入力値を代入
      for(var jj = 0; jj < length_array_names; jj++){
        if(name2 == array_names[jj]){
          var element_hidden4inputValue = getElementByName2(name + "_hidden4inputValue");
          if(element_hidden4inputValue != null){
            element.value = element_hidden4inputValue.value;
            break;
          }
        }
      }
    }
  }

  // 送信先URLを設定
  document.form.action = getURLBase(url);

  unlockFormFlag = false;

  // 送信
  document.form.submit();
}

/** データを送信 */
function post2(url){
  if(getElementByName2("_QUERY_IMPORT_FORM_HTML") == null)
    post(url);
}

/** 多重送信を禁止 */
function checkSubmitted(){
  // 参照用フォームの場合
  if( isReferenceForm() )
    return true;

  // 送信済みの場合
  if(getValueFromCookie("submittedForm") == document.URL){
    if( confirm("既に送信済みですが、再度送信しますか？") )
      return true;

    return false;
  // 未送信の場合
  } else {
    setValue2Cookie("submittedForm", document.URL);

    return true;
  }
}

/** 計算 */
function calculate(element, calcType, itemType, names_value, name_target){
  var name_srcElement = element.name;
  var result = 0;
  var length_names = names_value.length;

  switch(itemType){
    // 
    case 1:{
      var iRow = 0;
      var index_repeat = name_srcElement.indexOf("_R_");
      if(index_repeat > 0){
        iRow = Number( name_srcElement.substring(index_repeat + 3, name_srcElement.length) );

        for(var ii = 0; ii < length_names; ii++)
          names_value[ii] += "_R_" + iRow;

        name_target += "_R_" + iRow;
      }
    }
    break;

    // 
    case 2:{
      var name_value = names_value[0];
      var element_value = getElementByName2(name_value + "_R_1");
      var rowIndex = 0;

      var element_table = null;
      var element = element_value;
      while(true){
        if(element == null || element.tagName == "FORM")
          break;

        if(element.tagName == "TR"){
          rowIndex = element.rowIndex;
        } else if(element.tagName == "TABLE") {
          element_table = element;
          break;
        }

        element = element.parentNode;
      }

      // 
      if(element_table != null){
        names_value = new Array();

        // 
        var rows = element_table.getElementsByTagName("TR");
        if(rows != null){
          var length_rows = rows.length - rowIndex;
          for(var ii = 0; ii < length_rows; ii++)
            names_value.push(name_value + "_R_" + (ii + 1));

          length_names = names_value.length;
        }
      }
    }
    break;
  }

  for(var ii = 0; ii < length_names; ii++){
    // 文字列から数値関連文字以外の文字を削除
    var value = getNumberByName( names_value[ii] );

    // 値を初期設定
    if(ii == 0 && (calcType >= 1 && calcType <= 3)){
      result = value;
    } else {
      // 
      switch(calcType){
        // 和
        case 0:
          result += value;
          break;

        // 差
        case 1:
          result -= value;
          break;

        // 積
        case 2:
          result *= value;
          break;

        // 商
        case 3:
          result /= value;
          break;
      }
    }
  }

  // 
  switch(calcType){
    // 平均
    case 4:
      result = calculateAverage(names_value);
      break;

    // 最大
    case 5:
      result = calculateMax(names_value);
      break;

    // 最小
    case 6:
      result = calculateMin(names_value);
      break;
  }

  // 
  getElementByName2(name_target).value = result;

  // 値を隠しデータに保存
  setValue2Hidden(name_target, "_hidden4inputValue", result);
}

/** 平均を計算 */
function calculateAverage(names){
  var total = 0;

  var length_names = names.length;
  for(var ii = 0; ii < length_names; ii++)
    total += getNumberByName( names[ii] );

  return total / length_names;
}

/** 最大を計算 */
function calculateMax(names){
  var result = -Number.MAX_VALUE;

  var length_names = names.length;
  for(var ii = 0; ii < length_names; ii++)
    result = Math.max(result, getNumberByName( names[ii] ));

  return result;
}

/** 最小を計算 */
function calculateMin(names){
  var result = Number.MAX_VALUE;

  var length_names = names.length;
  for(var ii = 0; ii < length_names; ii++)
    result = Math.min(result, getNumberByName( names[ii] ));

  return result;
}

/** リンク */
function linkToURL(popup, href, width, height){
  // ポップアップウィンドウを表示
  if(popup)
    window.open(href, "", "menubar=1, scrollbars=1, status=1, resizable=1, width=" + width + ", " + "height=" + height);
  // 同一ウィンドウ内でリンク
  else
    window.location.href = href;
}

/** 属性を設定 */
function setAttribute4Component(attributes, names){
  // 配列数分ループ
  var length_names = names.length;
  for(var ii = 0; ii < length_names; ii++){
    var elements = getElementsByName2( names[ii] );
    if(elements == null)
      break;

    var nElement = elements.length;
    for(var jj = 0; jj < nElement; jj++){
      var element = elements[jj];

      // 前景色
      if( attributes[0] )
        element.style.color = attributes[1];
      // 背景色
      if( attributes[2] )
        element.style.backgroundColor = attributes[3];
      // フォント
      if( attributes[4] )
        element.style.fontFamily = attributes[5];
      // フォントサイズ
      if( attributes[6] )
        element.style.fontSize = attributes[7];
      // ボールド
      if(attributes[8] == 1)
        element.style.fontWeight = "bold";
      else if(attributes[8] == 2)
        element.style.fontWeight = "normal";
      // イタリック
      if(attributes[9] == 1)
        element.style.fontStyle = "italic";
      else if(attributes[9] == 2)
        element.style.fontStyle = "normal";
      // 有効
      if(attributes[10] == 1)
        element.disabled = false;
      else if(attributes[10] == 2)
        element.disabled = true;
      // 不透明
      if(attributes[11] == 1)
        element.style.visibility = "visible";
      else if(attributes[11] == 2)
        element.style.visibility = "hidden";
      // 値
      if( attributes[12] ){
        var value = attributes[13];

        if(element.tagName == "INPUT" && (element.type == "text" || element.type == "password"))
          value = value.replace(/\r\n+/ig, "");
        else if(element.tagName == "SPAN")
          value = value.replace(/\r\n+/ig, "<br>");

        setValue(element, value);

        // 値を隠しデータに保存
        setValue2Hidden(element.name, "_hidden4inputValue", value);
      }
      // クラス名
      if(attributes[14] != null){
        var str_className = attributes[14];
        if(str_className.indexOf("+") != -1){
          element.style.color = "";
          element.style.backgroundColor = "";
          element.style.fontFamily = "";
          element.style.fontSize = "";
          element.style.fontWeight = "";
          element.style.fontStyle = "";
          element.disabled = "";
          element.style.visibility = "";

          var name = getName(element);
          var name4hidden = "_hidden4className";

          var element_hidden = getElementByName2(name + name4hidden);
          if(element_hidden == null){
            element_hidden = document.createElement("input");
            element_hidden.name = name + name4hidden;
            element_hidden.id = element_hidden.name;
            element_hidden.type = "hidden";
            element_hidden.value = element.className;

            document.form.appendChild(element_hidden);
          } else {
            element.className = element_hidden.value;
          }

          element.className += str_className.replace(/\++/ig, " ");
        } else {
          element.className = str_className;
        }
      }
    }
  }
}

/** ポップアップウィンドウを表示 */
function createPopup(url, title, x, y, width, height){
  var style = ""

  if(x != null){
    style += "left=" + x + ",";
    style += "screenX=" + x + ",";
  }
  if(y != null){
    style += "top=" + y + ",";
    style += "screenY=" + y + ",";
  }
  style += "toolbar=no,";
  style += "location=no,";
  style += "directories=no,";
  style += "status=no,";
  style += "menubar=no,";
  style += "scrollbars=no,";
  style += "resizable=yes,";
  style += "innerWidth=" + width + ",";
  style += "innerHeight=" + height + ",";
  style += "width=" + width + ",";
  style += "height=" + height;

  return window.open(url, title, style);
}

var popup_calendar;

var date_now = new Date();
var date_now_temp = date_now;
var openPopup = true;

var year_set = -1;
var month_set = -1;
var day_set = -1;

/** カレンダーコントロールを表示 */
function calendar(nMonth, startType, name, str_format, arg1, arg2){
  var element = getElementByName2(name);
  element.blur();

  if(arguments.length <= 4){
    arg1 = 0;
    arg2 = 0;
  } else {
    openPopup = false;
  }

  if(arg1 == 0 && arg2 == 0)
    date_now = new Date();

  if(str_format != null){
    str_format = str_format.replace(/\"+/ig, "&quot;");
    str_format = str_format.replace(/\'+/ig, "\\\\'");
    str_format = "'" + str_format + "'";
  }

  // 年月日を取得
  year_now = date_now.getYear();
  if(year_now < 1900)
    year_now += 1900;
  month_now = date_now.getMonth();
  day_now = date_now.getDate();

  // 起動時に値を反映
  if(startType == 1){
    // 隠しデータの値を取得
    if(str_format != null){
      var element_hidden4inputValue = getElementByName2(name + "_hidden4inputValue");
      if(element_hidden4inputValue != null)
        element.value = element_hidden4inputValue.value;
    }

    var str_value = getValueByName(name);
    var tokens_value = str_value.split("/");
    if(tokens_value.length == 3){
      year_set = Number( tokens_value[0] );
      month_set = Number( tokens_value[1] ) - 1;
      day_set = Number( tokens_value[2] );
    } else {
      year_set = year_now;
      month_set = month_now;
      day_set = day_now;
    }
  // 全てのカレンダーコントロールで起動時に値を反映
  } else if(startType == 2) {
    if(year_set == -1 && month_set == -1 && day_set == -1){
      year_set = year_now;
      month_set = month_now;
      day_set = day_now;
    }
  } else {
    year_set = year_now;
    month_set = month_now;
    day_set = day_now;
  }

  // 月更新
  if(month_now == 11 && arg1 > 0){
    month_now = -1 + arg1;
    year_now++;
  } else if(month_now == 0 && arg1 < 0){
    month_now = 12 + arg1;
    year_now--;
  } else {
    month_now += arg1;
  }

  // 2000年問題対応
  if(year_now < 1900)
    year_now = 1900 + year_now;

  year_now += arg2;

  // 
  date_now = new Date(year_now, month_now, 1);

  // yyyymm
  var now_yyyymm = year_now * 100 + month_now;

  // yyyy/mm
  var title = year_now + "/" + (month_now + 1);

  var week = new Array("日", "月", "火", "水", "木", "金", "土");

  // カレンダーウィンドウを表示
  if(openPopup){
    var nRow = nMonth;
    if(nRow > 4)
      nRow = 4;
    var width = 170 * nRow - (3 * (nRow - 1));

    var nColumn = Math.ceil(nMonth / 4);
    var height = 190 * nColumn + 2;

    var x = 100;
    var y = 20;
    switch(browserType){
      // 
      case 0:
      case 2:
        if(event != null){
          x = event.screenX + 30;
          y = event.screenY - 180;
        }
        break;

      // 
      case 1:
        x += window.screenX;
        y += window.screenY;
        break;
    }

    // 
    popup_calendar = createPopup("", "", x, y, width, height);
  }

  // カレンダー構築用基準日の取得
  var date_first = date_now; // 今月の1日
  var time_first = date_first - (date_first.getDay() * 1000 * 60 * 60 * 24); // 最初の日曜日

  time_first = new Date(time_first);

  // HTML作成
  var str_html = "";
  str_html += "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\r\n";
  str_html += "<html>\r\n";
  str_html += "<head>\r\n";
  str_html += "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=shift_jis\">\r\n";
  str_html += "<title>ｶﾚﾝﾀﾞｰ</title>\r\n";
  str_html += "<style>\r\n";
  str_html += "  body { font: 18px; line-height: 12px; margin: 0px; }\r\n";
  str_html += "  th { font: 18px; line-height: 12px; font-weight: 900; }\r\n";
  str_html += "  td { font: 18px; font-family: Arial; line-height: 12px; }\r\n";
  str_html += "  a { text-decoration: none; color: #000000; font: 15px; font-family: Arial; line-height: 12px; }\r\n";
  str_html += "  input { font: 15px; font-family: Arial; line-height: 10px; padding: 0px; }\r\n";
  str_html += "</style>\r\n";
  str_html += "<script type=\"text/javascript\">\r\n";
  str_html += "<!--\r\n";
  str_html += "function setDateValue(name, date, str_format){\r\n";
  str_html += "  opener.setValue(opener.getElementByName2(name), date);\r\n";
  str_html += "\r\n";
  str_html += "  if(str_format != null)\r\n";
  str_html += "    opener.convertValue_format(opener.getElementByName2(name), str_format);\r\n";
  str_html += "\r\n";
  str_html += "  var str_value;\r\n";
  str_html += "  var element_hidden4inputValue = opener.getElementByName2(name + \"_hidden4inputValue\");\r\n";
  str_html += "  if(element_hidden4inputValue != null)\r\n";
  str_html += "    str_value = element_hidden4inputValue.value;\r\n";
  str_html += "  else\r\n";
  str_html += "    str_value = opener.getValueByName(name);\r\n";
  str_html += "\r\n";
  str_html += "  var tokens_value = str_value.split(\"/\");\r\n";
  str_html += "  if(tokens_value.length == 3){\r\n";
  str_html += "    opener.year_set = Number( tokens_value[0] );\r\n";
  str_html += "    opener.month_set = Number( tokens_value[1] ) - 1;\r\n";
  str_html += "    opener.day_set = Number( tokens_value[2] );\r\n";
  str_html += "  }\r\n";
  str_html += "\r\n";
  str_html += "  close();\r\n";
  str_html += "}\r\n";
  str_html += "-->\r\n";
  str_html += "</script>\r\n";
  str_html += "</head>\r\n";
  str_html += "<center>\r\n";
  str_html += "<body bgcolor=\"white\">\r\n";
  str_html += "<form>\r\n";

  var year_now2 = year_now;
  var month_now2 = month_now;
  var day_now2 = day_now;
  if(arguments[4] == null && arguments[5] == null){
    year_now2 = year_set;
    month_now2 = month_set;
    day_now2 = day_set;
  }

  now_yyyymm = year_now2 * 100 + month_now2;

  // 
  for(var ii = 0; ii < nMonth; ii++){
    date_now = new Date(year_now2, month_now2, 1);
    date_first = date_now; // 今月の1日
    time_first = date_first - (date_first.getDay() * 1000 * 60 * 60 * 24); // 最初の日曜日
    time_first = new Date(time_first);

    var left = (ii % 4) * 168;
    var top = Math.floor(ii / 4) * 190;

    str_html += "<table border=\"0\" bgcolor=\"#dddddd\" bordercolor=\"#dddddd\" width=\"170\" height=\"170\"";
    if(nMonth != 1)
      str_html += " style=\"position: absolute; left: " + left + "; top: " + top + "\";";
    str_html += ">\r\n";

    // 月
    str_html += "  <tr id=\"trmonth\" bgcolor=\"orange\" bordercolor=\"orange\" width=\"170\" height=\"17\">\r\n";
    str_html += "  <th colspan=\"7\" width=\"170\" height=\"17\" align=\"center\" style=\"font: 21px; line-height: 12px; font-weight: 900; margin: 0px; padding: 2px;\">\r\n";
    str_html += "    <nobr>\r\n";

    title = year_now2 + "/" + (month_now2 + 1);
    month_now2++;
    if(month_now2 >= 12){
      month_now2 = 0;
      year_now2++;
    }

    str_html += title + "<br>";

    str_html += "<br><input type=\"button\" style=\"font: 15px; font-family: Arial; line-height: 10px; padding: 0px; height: 25px;\" value=\"<<\" ";
    str_html += "onclick=\"opener.calendar(" + nMonth + ", " + startType + ", '" + name + "', " + str_format + ", 0, -1);\">";
    str_html += "<input type=\"button\" style=\"font: 15px; font-family: Arial; line-height: 10px; padding: 0px; height: 25px;\" value=\"<\" ";
    str_html += "onclick=\"opener.calendar(" + nMonth + ", " + startType + ", '" + name + "', " + str_format + ", -1, 0);\">";
    str_html += "<input type=\"button\" style=\"font: 15px; font-family: Arial; line-height: 10px; padding: 0px; height: 25px;\" value=\"o\" ";
    str_html += "onclick=\"opener.calendar(" + nMonth + ", " + startType + ", '" + name + "', " + str_format + ", 0, 0);\">";
    str_html += "<input type=\"button\" style=\"font: 15px; font-family: Arial; line-height: 10px; padding: 0px; height: 25px;\" value=\">\" ";
    str_html += "onclick=\"opener.calendar(" + nMonth + ", " + startType + ", '" + name + "', " + str_format + ", 1, 0);\">";
    str_html += "<input type=\"button\" style=\"font: 15px; font-family: Arial; line-height: 10px; padding: 0px; height: 25px;\" value=\">>\" ";
    str_html += "onclick=\"opener.calendar(" + nMonth + ", " + startType + ", '" + name + "', " + str_format + ", 0, 1);\">\r\n";

    str_html += "    </nobr>\r\n";
    str_html += "  </th>\r\n";
    str_html += "  </tr>\r\n";

    // 週
    str_html += "  <tr bgcolor=\"pink\" width=\"170\" height=\"17\">\r\n";

    for(var jj = 0; jj < 7; jj++){
      str_html += "    <th style=\"font: 16px;\" align=\"center\" width=\"17\" height=\"17\">";
      str_html +=       week[jj] + "\r\n";
      str_html += "    </th>\r\n";
    }
    str_html += "  </tr>\r\n";

    // 日
    for(var jj = 0; jj < 6; jj++){
      str_html += "  <tr bgcolor=\"#ffffff\">\r\n";

      for(var kk = 0; kk < 7; kk++){
        var day_next = time_first.getTime() + (kk * 1000 * 60 * 60 * 24);
        var date_next = new Date(day_next);

        wrtdate = date_next.getDate();
        var month_next = date_next.getMonth();
        var year_next = date_next.getYear();
        if(year_next < 1900)
          year_next += 1900;

        var next_yyyymm = year_next * 100 + month_next;
        var yyyymmdd = year_next + "/" + (month_next + 1) + "/" + wrtdate;

        var str_html_a  = "<a href=\"javascript:setDateValue('" + name + "', '" + yyyymmdd + "', " + str_format + ");\">";
            str_html_a += "<font color=\"#000000\">";
            str_html_a += wrtdate;
            str_html_a += "</font>";
            str_html_a += "</a>";

        // 
        if(next_yyyymm != now_yyyymm){ 
          str_html += "    <td align=\"center\" bgcolor=\"#cccccc\" width=\"17\" height=\"17\">";
          str_html += str_html_a;
        // 
        } else if(wrtdate  == date_now_temp.getDate()  && month_next == date_now_temp.getMonth() && date_next.getYear() == date_now_temp.getYear()) {
          str_html += "    <td align=\"center\" bgcolor=\"magenta\" width=\"17\" height=\"17\">";
          str_html += "<font color=\"#ffffff\">" + str_html_a + "</font>";
        // 
        } else if(wrtdate  == day_set && month_next == month_set) {
          var year_next = date_next.getYear();
          if(year_next < 1900)
            year_next += 1900;

          if(year_next == year_set){
            str_html += "    <td align=\"center\" bgcolor=\"lime\" width=\"17\" height=\"17\">";
            str_html += "<font color=\"#ffffff\">" + str_html_a + "</font>";
          } else {
            str_html += "    <td align=\"center\" width=\"17\" height=\"17\">";
            str_html += str_html_a;
          }
        // 
        } else {
          str_html += "    <td align=\"center\" width=\"17\" height=\"17\">";
          str_html += str_html_a;
        }

        str_html += "</td>\r\n";
      }

      str_html += "  </tr>\r\n";

      time_first = new Date(day_next);
      time_first = time_first.getTime() + (1000 * 60 * 60 * 24);
      time_first = new Date(time_first);
    }

    now_yyyymm = year_now2 * 100 + month_now2;

    str_html += "</table>\r\n";
  }

  month_now2 -= nMonth;
  if(month_now2 < 0){
    month_now2 += 12;
    year_now2--;
  }
  date_now = new Date(year_now2, month_now2, 1);
  day_now2 = date_now.getDate();

  str_html += "</form>\r\n";

  str_html += "</body>\r\n";
  str_html += "</center>\r\n";
  str_html += "</html>\r\n";

  // ウィンドウを表示
  popup_calendar.document.write(str_html);
  popup_calendar.document.close();
  popup_calendar.focus();

  openPopup = true;
}

var clockID;

/** 時刻を表示する */
function showClock(name, reload){
  updateClock(name, reload);

  // 時刻を更新する
  if(reload){
    clearTimeout(clockID);

    // 1秒毎にupdateClockを呼び出す
    clockID = setInterval("updateClock(\"" + name + "\", " + reload + ")", 1000);
  }
}

/** 時刻を更新する */
function updateClock(name, reload){
  var element = getElementByName2(name);
  if(element != null)
    setValue(element, new Date().toLocaleString());
}

/** キャレットを移動 */
function resetCaretPosition(element){
  if( !element.createTextRange )
    return;

  var textRange = element.createTextRange();
  if(textRange == null)
    return;

  textRange.collapse();
  textRange.move("character", element.value.length);
  textRange.select();

  return;
}

/** フォーカスを設定 */
function setFocus(name){
  var element = getElementByName2(name);
  if(element != null){
    if(element.disabled || element.type == "hidden"){
      element = getNextFocusElement(element, true);
      if(element == null)
        return;
    }

    try{
      element.focus();
    } catch(e) {
      return;
    }

    // テキストフィールド、テキストエリアの場合、キャレットを移動する
    if((element.tagName == "INPUT" && element.type == "text") || element.tagName == "TEXTAREA"){
      resetCaretPosition(element);

      // 値を選択する
      if(element.tagName == "INPUT")
        element.select();
    }
  }
}

/** 値がクッキーに登録済みかを検証 */
function isRegistInCookie(key){
  key = escape(key);

  var index = document.cookie.indexOf(key);
  if(index > 0){
    // 2番目以降に登録されている場合
    if(document.cookie.charAt(index - 2) == ";")
      return true;
  } else {
    // 登録されていない場合
    if(index == -1)
      return false;
    // 最初に登録されている場合
    else
      return true;
  }
}

/** 値をクッキーに設定 */
function setValue2Cookie(key, value){
  document.cookie = escape(key) + "=" + escape(value);
}

/** 値をクッキーから取得 */
function getValueFromCookie(key){
  // 値が登録されていない場合
  if( !isRegistInCookie(key) )
    return null;

  key = escape(key);

  var value = "";

  // 文字列を切り取る
  var token = document.cookie.split(key + "=");
  if(token.length > 1){
    value = document.cookie.split(key + "=")[1];
    value = unescape( value.split(";")[0] );
  }

  return value;
}

/** 値をUserDataに設定 */
function setValue2UserData(element, key, value){
  element.setAttribute(key, value);
  element.save(key);
}

/** 値をUserDataから取得 */
function getValueFromUserData(element, key){
  element.load(key);
  return element.getAttribute(key);
}

/** 値をUserDataから削除 */
function removeValueFromUserData(element, key){
  element.removeAttribute(key);
}

/** 値がUserDataに登録済みかを検証 */
function isRegistInUserData(element, key){
  element.load(key);

  // 登録されている場合
  if(element.getAttribute(key) != null)
    return true;
  // 登録されていない場合
  else
    return false;
}

/** Element配列中に指定されたElementが存在するか検証 */
function isSelectedElement(name, elements){
  // 
  var nElement = elements.length;
  for(var ii = 0; ii < nElement; ii++){
    if(getElementByName2( elements[ii] ).name == name)
      return true;
  }

  return false;
}

/** フォームデータをuserDataに保存 */
function saveFormData(isAll, elements){
  var all = getFormElements( document.form );

  // 
  var nElement = all.length;
  for(var ii = 0; ii < nElement; ii++){
    var element = all[ii];
    var name = element.name;
    if(element.type == "radio")
      name = element.className.replace(/\ /g, "_");

    // Element配列中に指定されたElementが存在するか検証
    if(!isAll && !isSelectedElement(element.name, elements))
      continue;

    // 入力アイテム以外の場合
    if(element.tagName != "INPUT" && element.tagName != "TEXTAREA" && element.tagName != "SELECT")
      continue;
    // ボタンの場合
    if(element.tagName == "INPUT" && element.type == "button")
      continue;

    // 値をUserDataから取得
    var value = getValueFromUserData(element, name);

    // 値が設定されていない、または値が異なる場合
    if(value == null || value != element.value){
      value = element.value;

      // 
      if(element.tagName == "INPUT"){
        // チェックボックスの場合
        if(element.type == "checkbox"){
          value = element.checked;
        // ラジオボタンの場合
        } else if(element.type == "radio") {
          value = element.checked + "\\" + escape( element.value );
        }
      // コンボボックス、リストの場合
      } else if(element.tagName == "SELECT") {
        value = "";

        var length_options = element.options.length;
        for(var jj = 0; jj < length_options; jj++){
          value += element.options[jj].selected;

          if(jj != length_options - 1)
            value += "\\";
        }
      }

      // 値をUserDataに設定
      setValue2UserData(element, name, value);
    }
  }
}

/** フォームデータをuserDataから取得 */
function getFormData(isAll, elements){
  var all = getFormElements( document.form );

  // 
  var nElement = all.length;
  for(var ii = 0; ii < nElement; ii++){
    var element = all[ii];
    var name = element.name;
    if(element.type == "radio")
      name = element.className.replace(/\ /g, "_");

    // 値がUserDataに登録済みかを検証
    if( !isRegistInUserData(element, name) )
      continue;

    // Element配列中に指定されたElementが存在するか検証
    if(!isAll && !isSelectedElement(element.name, elements))
      continue;

    // 値をUserDataから取得
    var value = getValueFromUserData(element, name);

    // 値が設定されている場合
    if(value != null){
      // 
      if(element.tagName == "INPUT"){
        // チェックボックスの場合
        if(element.type == "checkbox"){
          if(value == "true")
            element.checked = true;
          else
            element.checked = false;
        // ラジオボタンの場合
        } else if(element.type == "radio") {
          element.checked = false;

          var token = value.split("\\");

          if(token[0] == "true" && element.value == token[1])
            element.checked = true;
        // テキストフィールド、パスワードフィールド、テキストエリアの場合
        } else {
          element.value = value;
        }
      // コンボボックス、リストの場合
      } else if(element.tagName == "SELECT") {
        var token = value.split("\\");

        var length_options = element.options.length;
        for(var jj = 0; jj < length_options; jj++){
          if(token[jj] == "true")
            element.options[jj].selected = true;
          else
            element.options[jj].selected = false;
        }
      // 
      } else {
        element.value = value;
      }
    }
  }
}

/** フォームデータをuserDataから削除 */
function deleteFormData(isAll, elements){
  var all = getFormElements( document.form );

  // 
  var nElement = all.length;
  for(var ii = 0; ii < nElement; ii++){
    var element = all[ii];
    var name = element.name;
    if(element.type == "radio")
      name = element.className.replace(/\ /g, "_");

    // Element配列中に指定されたElementが存在するか検証
    if(!isAll && !isSelectedElement(element.name, elements))
      continue;

    // 入力アイテム以外の場合
    if(element.tagName != "INPUT" && element.tagName != "TEXTAREA" && element.tagName != "SELECT")
      continue;
    // ボタンの場合
    if(element.tagName == "INPUT" && element.type == "button")
      continue;

    // 値をUserDataに設定
    setValue2UserData(element, name, "");
  }
}

/** 送信データを削除 */
function deletePostData(){
  if( confirm("送信データを削除しますか?") )
    post("./FormDataRemover?responseType=REMOVE");
}

/** 呼び出し元フォームのElementに値を設定 */
function setValue2Opener(names_child, name_parent){
  var value = "";

  // 設定する値を作成
  var length_names_child = names_child.length;
  for(var ii = 0; ii < length_names_child; ii++){
    var element_child = getElementByName2( names_child[ii] );
    if(element_child != null)
      value += element_child.value;
  }

  // 呼び出し元フォームのElementを取得
  var element_parent = opener.document.getElementsByName(name_parent)[0];
  // 値を設定
  if(element_parent != null)
    element_parent.value = value;
}

/** 呼び出し元フォームのElementに値を設定（複数） */
function setValues2Opener(names_child, names_parent){
  // 
  var length_names_child = names_child.length;
  for(var ii = 0; ii < length_names_child; ii++){
    // フォームのElementを取得
    var element_child = getElementByName2( names_child[ii] );
    if(element_child == null)
      continue;

    // 呼び出し元フォームのElementを取得
    var element_parent = opener.document.getElementsByName( names_parent[ii] )[0];
    // 値を設定
    if(element_parent != null)
      element_parent.value = element_child.value;
  }
}

/** 画像用ウィンドウを表示 */
function showPopup4Image(src, magnifyRate_w, magnifyRate_h, fit, width, height){
  // IMGタグを作成
  var element_img = document.createElement("img");
  element_img.setAttribute("src", src);

  var popup_image = createPopup("", "", null, null, width, height);

  var str_html = "";
  str_html += "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\r\n";
  str_html += "<html>\r\n";
  str_html += "<head>\r\n";
  str_html += "<script type=\"text/javascript\">\r\n";
  str_html += "<!--\r\n";
  str_html += "  function showPopup4Image(src, magnifyRate_w, magnifyRate_h, fit, width, height){\r\n";
  str_html += "    var image = new Image();\r\n";
  str_html += "    image.src = src;\r\n";
  str_html += "\r\n";
  str_html += "    // 画像サイズを拡大、縮小する場合\r\n";
  str_html += "    if( !fit ){\r\n";
  str_html += "      width = image.width * magnifyRate_w;\r\n";
  str_html += "      height = image.height * magnifyRate_h;\r\n";
  str_html += "    }\r\n";
  str_html += "\r\n";
  str_html += "    var element_img = document.getElementsByName(\"image\")[0];\r\n";
  str_html += "    element_img.width = width;\r\n";
  str_html += "    element_img.height = height;\r\n";
  str_html += "\r\n";
  str_html += "    window.innerWidth = width;\r\n";
  str_html += "    window.innerHeight = height;\r\n";

  var height_diff = 0;
  switch(browserType){
    // 
    case 0:
    case 2:
      width_diff = 16;
      height_diff = 64;
      break;

    // 
    case 1:
      width_diff = 32;
      height_diff = 52;
      break;
  }
  str_html += "    window.resizeTo(width + " + width_diff + ", height + " + height_diff + ");\r\n";

  str_html += "  }\r\n";
  str_html += "-->\r\n";
  str_html += "</script>\r\n";
  str_html += "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=shift_jis\">\r\n";
  str_html += "<title>" + src + "</title>\r\n";
  str_html += "</head>\r\n";
  str_html += "<body onload=\"showPopup4Image('" + src + "', " + magnifyRate_w + ", " + magnifyRate_h + ", " + fit + ", " + width + ", " + height + ");\">\r\n";
  str_html += "<center>\r\n";
  str_html += "<img name=\"image\" src=\"" + src + "\">\r\n";
  str_html += "</center>\r\n";
  str_html += "</body>\r\n";
  str_html += "</html>\r\n";

  // ウィンドウを表示
  popup_image.document.write(str_html);
  popup_image.document.close();
  popup_image.focus();
}

/** 動的にテーブル行を追加 */
function addRowDynamically(element, type, tableID, pos){
  // 送信先URLを設定
  document.form.action = "XmlImporter";

  // 隠しデータを設定
  document.form.TABLE_ID.value = tableID;
  document.form.TABLE_FUNCTION.value = pos;
  document.form.COUNT.value = "1";
  document.form.BTN_NAME.value = element.name;
  document.form.ADDROW_TYPE.value = type;

  // データを送信
  post( document.form.action );
}

/** 動的にテーブル行を削除 */
function deleteRowDynamically(element, tableID){
  var element_table = getElementByNameFromDocument(tableID);
  var nAction = 0;
  var str_triggers = new Array("onclick", "ondblclick", "onmousedown", "onmouseup", "onmouseover", "onmouseout", "onkeydown", "onkeyup", "onfocus", "onblur", "onchange");
  var length_str_triggers = str_triggers.length;

  // 行追加、削除対象行数をカウント
  var rows = element_table.getElementsByTagName("TR");
  if(rows != null){
    var length_rows = rows.length;
    for(var ii = 0; ii < length_rows; ii++){
      // 行を取得
      var row = rows[ii];
      var includeAction = false;

      // セル配列を取得
      var cells = row.getElementsByTagName("TD");
      var length_cells = cells.length;
      for(var jj = 0; jj < length_cells; jj++){
        // セルを取得
        var cell = cells[jj];
        // セル内Element配列を取得
        var childNodes = cell.childNodes;

        var length_childNodes = childNodes.length;
        for(var kk = 0; kk < length_childNodes; kk++){
          var child = childNodes[kk];

          // 各トリガに登録されているアクションを調査
          for(var ll = 0; ll < length_str_triggers; ll++){
            var str_trigger = str_triggers[ll];
            var attributes = child.attributes;
            if(attributes != null && attributes.getNamedItem(str_trigger) != null && attributes.getNamedItem(str_trigger).nodeValue != null){
              var nodeValue = attributes.getNamedItem(str_trigger).nodeValue;
              if(nodeValue.indexOf("addRowDynamically") != -1 || nodeValue.indexOf("deleteRowDynamically") != -1){
                includeAction = true;
                break;
              }
            }
          }
        }

        if(includeAction){
          nAction++;
          break;
        }
      }
    }
  }

  // エラーメッセージを表示
  if(nAction <= 1){
    alert("最後の行は削除出来ません");
    return;
  }

  // 送信先URLを設定
  document.form.action = "XmlImporter";

  // 隠しデータを設定
  document.form.TABLE_ID.value = tableID;
  document.form.TABLE_FUNCTION.value = "delete";
  document.form.COUNT.value = "1";
  document.form.BTN_NAME.value = element.name;

  // データを送信
  post( document.form.action );
}

/**  */
function getItemValue(element){
  var values = new Array();

  // コンボボックス、リストの場合
  if(element.tagName == "SELECT"){
    var nSelected = 0;
    var nMatch_select = 0;

    var length_options = element.options.length;
    for(var ii = 0; ii < length_options; ii++){
      if( element.options[ii].selected )
        values.push( element.options[ii].value );
    }
  } else {
    // チェックボックス場合
    if(element.type == "checkbox"){
      if( element.checked )
        values.push( element.value );
    // ラジオボタンの場合
    } else if(element.type == "radio") {
      if( element.checked )
        values.push( element.value );
    // テキストフィールド、パスワードフィールド、テキストエリアの場合
    } else {
      values.push( element.value );
    }
  }

  return values;
}

/** アイテムが入力済みか判定 */
function isInputtedItem(element){
  var isInputted = false;

  // ラベルの場合
  if(element.tagName == "SPAN"){
    if(element.innerHTML != "")
      isInputted = true;
  // コンボボックス、リストの場合
  } else if(element.tagName == "SELECT") {
    var length_options = element.options.length;
    for(var ll = 0; ll < length_options; ll++){
      if( element.options[ll].selected ){
        isInputted = true;
        break;
      }
    }
  } else {
    // チェックボックス場合
    if(element.type == "checkbox"){
      if( element.checked )
        isInputted = true;
    // ラジオボタンの場合
    } else if(element.type == "radio") {
      if( element.checked )
        isInputted = true;
    // テキストフィールド、パスワードフィールド、テキストエリアの場合
    } else {
      if( element.value )
        isInputted = true;
    }
  }

  return isInputted;
}

/** テーブルの行、列を削除 */
function deleteTable(isRow, type, name_table, elements){
  // 指定Elementに値が入力されていなければ削除
  if(type == 0){
    // テーブルElementを取得
    var tables;
    switch(browserType){
      // 
      case 0:
      case 2:
        tables = document.all.tags("TABLE");
        break;

      // 
      case 1:
        tables = document.getElementsByTagName("TABLE");
        break;
    }

    var length_tables = tables.length;
    var nElement = elements.length;
    for(var ii = 0; ii < length_tables; ii++){
      for(var jj = 0; jj < nElement; jj++){
        // 行を削除
        if(isRow)
          deleteRowByValue(tables[ii], elements[jj]);
        // 列を削除
        else
          deleteColumnByValue(tables[ii], elements[jj]);
      }
    }
  // 強制的に削除
  } else {
    // テーブルElementを取得
    var table = getElementByName2(name_table);

    // 行を削除
    if(isRow)
      deleteRowCompulsorily(table, elements);
    // 列を削除
    else
      deleteColumnCompulsorily(table, elements);
  }
}

/** 指定Elementに値が入力されていなければテーブル行を削除 */
function deleteRowByValue(table, name){
  if(table == null)
    return;

  // 行配列を取得
  var rows = table.getElementsByTagName("TR");
  if(rows == null)
    return;

  var length_rows = rows.length;
  for(var ii = 0; ii < length_rows; ii++){
    // 行を取得
    var row = rows[ii];

    // セル配列を取得
    var cells = row.getElementsByTagName("TD");
    var length_cells = cells.length;
    for(var jj = 0; jj < length_cells; jj++){
      // セルを取得
      var cell = cells[jj];
      // セル内Element配列を取得
      var childNodes = cell.childNodes;

      var length_childNodes = childNodes.length;
      for(var kk = 0; kk < length_childNodes; kk++){
        var child = childNodes[kk];

        // テーブルの場合、再帰処理
        if(child.tagName == "TABLE"){
          deleteRowByValue(child, name);
        } else {
          // 値が入力されていない場合
          if(name == getName(child) && !isInputtedItem(child)){
            // 行数
            var rowspan;
            switch(browserType){
              // 
              case 0:
              case 2:
                rowspan = new Number( cell.attributes.getNamedItem("rowspan").nodeValue );
                break;

              // 
              case 1:
                rowspan = cell.rowspan
                break;
            }

            if(rowspan == null)
              rowspan = 1;

            for(var ll = ii + rowspan - 1; ll >= ii; ll--){
              var row2 = rows[ll];

              // セル配列を取得
              var cells2 = row2.getElementsByTagName("TD");
              var length_cells2 = cells2.length;
              for(var mm = 0; mm < length_cells2; mm++){
                // セルを取得
                var cell2 = cells2[mm];
                // セル内Element配列を取得
                var childNodes2 = cell2.childNodes;

                var length_childNodes2 = childNodes2.length;
                for(var nn = 0; nn < length_childNodes2; nn++){
                  var child2 = childNodes2[nn];
                  if(child2.name != null){
                    // 値を隠しデータに保存
                    var values = getItemValue(child2);
                    if(values.length > 0)
                      setValue2Hidden(child2.name, "_hidden4post", values[0]);
                  }
                }
              }

              // 行を削除
              table.deleteRow(ll);
            }

            return;
          }
        }
      }
    }
  }
}

/** 指定Elementに値が入力されていなければテーブル列を削除 */
function deleteColumnByValue(table, name){
  if(table == null)
    return;

  // 行配列を取得
  var rows = table.getElementsByTagName("TR");
  if(rows == null)
    return;

  var found = false;
  // 列インデックス配列
  var iColumns = new Array(1);

  var length_rows = rows.length;
  for(var ii = 0; ii < length_rows; ii++){
    // 行を取得
    var row = rows[ii];

    // セル配列を取得
    var cells = row.getElementsByTagName("TD");
    var length_cells = cells.length;
    for(var jj = 0; jj < length_cells; jj++){
      // セル内Element配列を取得
      var childNodes = cells[jj].childNodes;

      var length_childNodes = childNodes.length;
      for(var kk = 0; kk < length_childNodes; kk++){
        var child = childNodes[kk];

        // テーブルの場合、再帰処理
        if(child.tagName == "TABLE"){
          deleteColumnByValue(child, name);
        } else {
          // 値が入力されていない場合
          if(name == getName(child) && !isInputtedItem(child)){
            iColumns[0] = jj + 1;
            found = true;

            break;
          }
        }
      }
    }
  }

  // 強制的にテーブル列を削除
  if(found)
    deleteColumnCompulsorily(table, iColumns);
}

/** 強制的にテーブル行を削除 */
function deleteRowCompulsorily(table, indices){
  if(table == null)
    return;

  // 行配列を取得
  var rows = table.getElementsByTagName("TR");
  if(rows == null)
    return;

  var length_rows = rows.length;
  var length_indices = indices.length;
  for(var ii = length_rows - 1; ii >= 0; ii--){
    for(var jj = 0; jj < length_indices; jj++){
      // 行を削除
      if(ii == indices[jj] - 1)
        table.deleteRow(ii);
    }
  }
}

/** 強制的にテーブル列を削除 */
function deleteColumnCompulsorily(table, indices){
  if(table == null)
    return;

  // 行配列を取得
  var rows = table.getElementsByTagName("TR");
  if(rows == null)
    return;

  var length_indices = indices.length;
  var length_row = rows.length;
  for(var ii = length_indices - 1; ii >= 0; ii--){
    var index = indices[ii] - 1;

    for(var jj = 0; jj < length_row; jj++){
      // 行を取得
      var row = rows[jj];
      // セル配列を取得
      var cells = row.getElementsByTagName("TD");
      var iCell = 0;

      var length_cells = cells.length;
      for(var kk = 0; kk < length_cells; kk++){
        // セルを取得
        var cell = cells[kk];

        // 行数
        var rowspan;
        switch(browserType){
          // 
          case 0:
          case 2:
            rowspan = new Number( cell.attributes.getNamedItem("rowspan").nodeValue );
            break;

          // 
          case 1:
            rowspan = cell.rowspan;
            break;
        }

        if(rowspan == null)
          rowspan = 1;

        // 列数
        var colspan;
        switch(browserType){
          // 
          case 0:
          case 2:
            colspan = new Number( cell.attributes.getNamedItem("colspan").nodeValue );
            break;

          // 
          case 1:
            colspan = cell.colspan;
            break;
        }

        if(colspan == null)
          colspan = 1;

        // 
        if(iCell == index){
          // 列を削除
          row.deleteCell(kk);

          jj += rowspan - 1;
          break;
        }

        iCell += colspan;
      }
    }
  }
}

/** checkEssentialItems() for custom script */
function checkEssentialItems4CustomScript(){
  return checkEssentialItems2( new Array() );
}

